
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 20.000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': No
;'char' is unsigned     : No
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _gNumLine=R2
	.DEF _gVideoBuffPoint=R5
	.DEF _gVideoBuffPoint_msb=R6
	.DEF _gSendUartCnt=R4
	.DEF _gSendUartInd=R7
	.DEF _gTrack_azimuth=R8
	.DEF _gTrack_azimuth_msb=R9
	.DEF _gTrack_elevation=R11
	.DEF _gOff_azimuth=R12
	.DEF _gOff_azimuth_msb=R13
	.DEF _f_flash=R10

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _ana_comp_isr
	RJMP 0x00
	RJMP 0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <string.h>
;#include <delay.h>
;
;#define HIGH(a) (a>>8)
;#define LOW(a) (a & 0xff)
;#define u_char unsigned char
;#define s_char signed char
;#define u_int unsigned int
;#define s_int signed int
;#define u_long unsigned long
;#define s_long signed long
;
;#define LED_ERR PORTD.5
;#define LED_LowBat PORTB.0
;#define LED_RSSI PORTB.3
;
;#define BUZ_1 PORTD.4
;#define BUZ_2 PORTB.3
;
;#define IN_KEY PINB.4
;#define IN_KEY_1 PINC.3
;
;
;#define HSIZE_SCR 96
;#asm (".equ HSIZE_SCR=96")
	.equ HSIZE_SCR=96
;#define BYTES_FROM_STRING (HSIZE_SCR/8)
;#asm (".equ BYTES_FROM_STRING=(HSIZE_SCR/8)")
	.equ BYTES_FROM_STRING=(HSIZE_SCR/8)
;//-------------------------------------------------
;struct
;{
;u_int OutPPM_Min[2];
;u_int OutPPM_Max[2];
;}gCallibr;
;//----------------------------------------------------------------------
;register u_char gNumLine @2;
;register u_char* gVideoBuffPoint @5;
;#asm (".def gVideoBuffPointL=R5")
	.def gVideoBuffPointL=R5
;#asm (".def gVideoBuffPointH=R6")
	.def gVideoBuffPointH=R6
;#define START_LINE_TT 24
;#define COUNT_LINE_TT 2
;//----------------------------------------------------------------------
;u_char gVideoBuff[COUNT_LINE_TT][BYTES_FROM_STRING+2];
;#define SIZE_UART_BUFF 100
;#define SYN_UART 0x5a
;
;#define long_delay 200
;#define change_mode_delay 50
;#define short_delay 25
;#define programm_buzz_delay 50
;#define blink_delay 25
;//     .
;//     .
;#define servo_min_limit 1500 // .6ms
;#define servo_max_limit 6000 // 2.4ms
;
;u_char gSendUartCnt;
;u_char gSendUartInd;
;u_char gSendUartBuff[2+1+1+SIZE_UART_BUFF+1];
;
;u_int gTrack_azimuth;
;u_char gTrack_elevation;
;u_int gOff_azimuth;
;
;eeprom u_int EEP_Off_azimuth @16;
;eeprom u_int EEP_azimuth_min_limit @18;
;eeprom u_int EEP_azimuth_max_limit @20;
;eeprom u_int EEP_elevation_min_limit @22;
;eeprom u_int EEP_elevation_max_limit @24;
;eeprom u_char EEP_mode360 @26;
;
;u_char f_flash;
;u_char gfRX;
;u_char gCCNT0;
;u_char gOldCnt0;
;u_char gErrCnt;
;u_char mode_360_ram;
;
;//---------------------------------------------------------------
;//---------------------------------------------------------------
;//---------------------------------------------------------------
;#define POLINOM 33800   // x^0+x^5+x^12, (15-0)+(15-5)+(15-12)
;u_int CalcCRC_TT(u_char *buff)
; 0000 0054 {

	.CSEG
_CalcCRC_TT:
; .FSTART _CalcCRC_TT
; 0000 0055 union  { u_int r; u_char rb[2]; } rr;
; 0000 0056 u_char i;
; 0000 0057 u_char m, pr;
; 0000 0058 u_char *p;
; 0000 0059 
; 0000 005A p=buff;
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,2
	RCALL __SAVELOCR6
;	*buff -> Y+8
;	rr -> Y+6
;	i -> R17
;	m -> R16
;	pr -> R19
;	*p -> R20,R21
	__GETWRS 20,21,8
; 0000 005B rr.r=POLINOM;
	LDI  R30,LOW(33800)
	LDI  R31,HIGH(33800)
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 005C for(i=0; i<BYTES_FROM_STRING-1; i++, p++)
	LDI  R17,LOW(0)
_0x4:
	CPI  R17,11
	BRSH _0x5
; 0000 005D   {
; 0000 005E   for(m=1; m; m<<=1)
	LDI  R16,LOW(1)
_0x7:
	CPI  R16,0
	BREQ _0x8
; 0000 005F     {
; 0000 0060     pr=(rr.rb[0] & 1);
	LDD  R30,Y+6
	ANDI R30,LOW(0x1)
	MOV  R19,R30
; 0000 0061     rr.r>>=1;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LSR  R31
	ROR  R30
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 0062     if(*p & m)  rr.rb[1]|=0x80;
	MOVW R26,R20
	LD   R30,X
	AND  R30,R16
	BREQ _0x9
	MOVW R26,R28
	ADIW R26,7
	LD   R30,X
	ORI  R30,0x80
	ST   X,R30
; 0000 0063     if(pr)  rr.r^=POLINOM;
_0x9:
	CPI  R19,0
	BREQ _0xA
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(33800)
	LDI  R31,HIGH(33800)
	EOR  R30,R26
	EOR  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 0064     }
_0xA:
	LSL  R16
	RJMP _0x7
_0x8:
; 0000 0065   }
	SUBI R17,-1
	__ADDWRN 20,21,1
	RJMP _0x4
_0x5:
; 0000 0066 return rr.r;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __LOADLOCR6
	ADIW R28,10
	RET
; 0000 0067 }
; .FEND
;//---------------------------------------------------------------
;typedef struct
;{
;//u_char start_byte;      // 1.   0xff
;u_char num_frame_line;  // 2.   0x00
;s_int Track_azimuth;    // 3,4
;s_int Track_elevation;  // 5,6 u_char enough!!
;u_char Reserve[4];      // 7,8,9,10
;u_int  CRC;             // 11,12
;}TT_FRAME_00;
;//---------------------------------------------------------------
;typedef struct
;{
;//u_char start_byte;      // 1.   0xff
;u_char num_frame_line;  // 2.   0x10
;u_long GPS_lat;         // 3,4,5,6
;u_long GPS_lon;         // 7,8,9,10
;u_int  CRC;             // 11,12
;}TT_FRAME_01;
;//----------------------------------------------------------------------
;typedef struct
;{
;s_int  Track_azimuth;     // 1,2
;s_int  Track_elevation;  // 3,4
;u_long GPS_lat;          // 5,6,7,8
;u_long GPS_lon;          // 9,10,11,12
;u_int  AV_RSSI;          // 13,14
;u_char AVErrors;         // 15
;u_int rezerved;          // 16,17
;}TO_HOST_DATA;
;//----------------------------------------------------------------------
;TO_HOST_DATA gHostData;
;//----------------------------------------------------------------------
;void rec_v_data(void)
; 0000 008A {
_rec_v_data:
; .FSTART _rec_v_data
; 0000 008B u_int n;
; 0000 008C TT_FRAME_00 *TT_Frame00;
; 0000 008D TT_FRAME_01 *TT_Frame01;
; 0000 008E 
; 0000 008F //top line
; 0000 0090 n=CalcCRC_TT(gVideoBuff[0]);
	RCALL __SAVELOCR6
;	n -> R16,R17
;	*TT_Frame00 -> R18,R19
;	*TT_Frame01 -> R20,R21
	LDI  R26,LOW(_gVideoBuff)
	LDI  R27,HIGH(_gVideoBuff)
	RCALL _CalcCRC_TT
	MOVW R16,R30
; 0000 0091 if(n==0)
	MOV  R0,R16
	OR   R0,R17
	BRNE _0xB
; 0000 0092   {
; 0000 0093   if(gVideoBuff[0][0]==0)
	LDS  R30,_gVideoBuff
	CPI  R30,0
	BRNE _0xC
; 0000 0094     {
; 0000 0095     TT_Frame00=(TT_FRAME_00 *)gVideoBuff[0];
	__POINTWRM 18,19,_gVideoBuff
; 0000 0096     gTrack_azimuth=TT_Frame00->Track_azimuth;
	MOVW R26,R18
	ADIW R26,1
	LD   R8,X+
	LD   R9,X
; 0000 0097     gTrack_elevation=(u_char)TT_Frame00->Track_elevation;
	MOVW R30,R18
	LDD  R11,Z+3
; 0000 0098     }
; 0000 0099   }
_0xC:
; 0000 009A else gErrCnt++;
	RJMP _0xD
_0xB:
	LDS  R30,_gErrCnt
	SUBI R30,-LOW(1)
	STS  _gErrCnt,R30
; 0000 009B //bottom line
; 0000 009C n=CalcCRC_TT(gVideoBuff[1]);
_0xD:
	__POINTW2MN _gVideoBuff,14
	RCALL _CalcCRC_TT
	MOVW R16,R30
; 0000 009D if(n==0)
	MOV  R0,R16
	OR   R0,R17
	BRNE _0xE
; 0000 009E   {
; 0000 009F   if(gVideoBuff[1][0]==0x10)
	__GETB2MN _gVideoBuff,14
	CPI  R26,LOW(0x10)
	BRNE _0xF
; 0000 00A0     {
; 0000 00A1     TT_Frame01=(TT_FRAME_01 *)gVideoBuff[1];
	__POINTWRMN 20,21,_gVideoBuff,14
; 0000 00A2     gHostData.GPS_lat=TT_Frame01->GPS_lat;
	MOVW R26,R20
	ADIW R26,1
	RCALL __GETD1P
	__PUTD1MN _gHostData,4
; 0000 00A3     gHostData.GPS_lon=TT_Frame01->GPS_lon;
	MOVW R26,R20
	ADIW R26,5
	RCALL __GETD1P
	__PUTD1MN _gHostData,8
; 0000 00A4     }
; 0000 00A5   }
_0xF:
; 0000 00A6 else gErrCnt++;
	RJMP _0x10
_0xE:
	LDS  R30,_gErrCnt
	SUBI R30,-LOW(1)
	STS  _gErrCnt,R30
; 0000 00A7 gfRX=1;
_0x10:
	LDI  R30,LOW(1)
	STS  _gfRX,R30
; 0000 00A8 if(gErrCnt==0) { gCCNT0=short_delay; TCNT0=0; gOldCnt0=0; } // syn main loop
	LDS  R30,_gErrCnt
	CPI  R30,0
	BRNE _0x11
	LDI  R30,LOW(25)
	STS  _gCCNT0,R30
	LDI  R30,LOW(0)
	OUT  0x32,R30
	STS  _gOldCnt0,R30
; 0000 00A9 }
_0x11:
	RJMP _0x2020005
; .FEND
;//----------------------------------------------------------------------
;u_int read_adc(u_char adc_input)
; 0000 00AC {
_read_adc:
; .FSTART _read_adc
; 0000 00AD #define ADC_VREF_TYPE 0x40 // AVCC pin
; 0000 00AE ADMUX=adc_input | ADC_VREF_TYPE;
	ST   -Y,R26
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
; 0000 00AF delay_us(10);
	__DELAY_USB 67
; 0000 00B0 ADCSRA|=0x40; // Start the AD conversion
	SBI  0x6,6
; 0000 00B1 while ((ADCSRA & 0x10)==0);
_0x12:
	SBIS 0x6,4
	RJMP _0x12
; 0000 00B2 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 00B3 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 00B4 }
; .FEND
;//----------------------------------------------------------------------
;#define RSSI_R1 2
;#define RSSI_R2 10
;void GetAV_RSSI(void)
; 0000 00B9 {
_GetAV_RSSI:
; .FSTART _GetAV_RSSI
; 0000 00BA u_long ln;
; 0000 00BB //u_int rssi;
; 0000 00BC 
; 0000 00BD ln=read_adc(0);
	SBIW R28,4
;	ln -> Y+0
	LDI  R26,LOW(0)
	RCALL _read_adc
	CLR  R22
	CLR  R23
	RCALL __PUTD1S0
; 0000 00BE //rssi=((ln*300)/1024)/10
; 0000 00BF 
; 0000 00C0 //--
; 0000 00C1 #define LEVEL1 335 //   9,8V
; 0000 00C2 #define LEVEL2 311 //   9,1V
; 0000 00C3 if(ln<LEVEL2) { LED_LowBat=1; BUZ_2=1;}
	RCALL __GETD2S0
	__CPD2N 0x137
	BRSH _0x15
	SBI  0x18,0
	SBI  0x18,3
; 0000 00C4 else if(ln<LEVEL1) { LED_LowBat=f_flash; BUZ_2=f_flash; }
	RJMP _0x1A
_0x15:
	RCALL __GETD2S0
	__CPD2N 0x14F
	BRSH _0x1B
	MOV  R30,R10
	CPI  R30,0
	BRNE _0x1C
	CBI  0x18,0
	RJMP _0x1D
_0x1C:
	SBI  0x18,0
_0x1D:
	MOV  R30,R10
	CPI  R30,0
	BRNE _0x1E
	CBI  0x18,3
	RJMP _0x1F
_0x1E:
	SBI  0x18,3
_0x1F:
; 0000 00C5 else { LED_LowBat=0; BUZ_2=0; }
	RJMP _0x20
_0x1B:
	CBI  0x18,0
	CBI  0x18,3
_0x20:
_0x1A:
; 0000 00C6 gHostData.AV_RSSI=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _gHostData,12
; 0000 00C7 }
	ADIW R28,4
	RET
; .FEND
;//----------------------------------------------------------------------
;void GetAVErrors(void)
; 0000 00CA {
_GetAVErrors:
; .FSTART _GetAVErrors
; 0000 00CB static u_char div;
; 0000 00CC 
; 0000 00CD if(gfRX==0) gErrCnt+=2;
	LDS  R30,_gfRX
	CPI  R30,0
	BRNE _0x25
	LDS  R30,_gErrCnt
	SUBI R30,-LOW(2)
	STS  _gErrCnt,R30
; 0000 00CE else gfRX=0;
	RJMP _0x26
_0x25:
	LDI  R30,LOW(0)
	STS  _gfRX,R30
; 0000 00CF if(div < short_delay) div++;
_0x26:
	LDS  R26,_div_S0000004000
	CPI  R26,LOW(0x19)
	BRSH _0x27
	LDS  R30,_div_S0000004000
	SUBI R30,-LOW(1)
	STS  _div_S0000004000,R30
; 0000 00D0 else
	RJMP _0x28
_0x27:
; 0000 00D1   {
; 0000 00D2   div=0;
	LDI  R30,LOW(0)
	STS  _div_S0000004000,R30
; 0000 00D3   if(gErrCnt>52) gErrCnt=52;
	LDS  R26,_gErrCnt
	CPI  R26,LOW(0x35)
	BRLO _0x29
	LDI  R30,LOW(52)
	STS  _gErrCnt,R30
; 0000 00D4   if(gErrCnt>short_delay) LED_ERR=1;
_0x29:
	LDS  R26,_gErrCnt
	CPI  R26,LOW(0x1A)
	BRLO _0x2A
	SBI  0x12,5
; 0000 00D5   else LED_ERR=0;
	RJMP _0x2D
_0x2A:
	CBI  0x12,5
; 0000 00D6   gHostData.AVErrors=gErrCnt;
_0x2D:
	LDS  R30,_gErrCnt
	__PUTB1MN _gHostData,14
; 0000 00D7   gErrCnt=0;
	LDI  R30,LOW(0)
	STS  _gErrCnt,R30
; 0000 00D8   }
_0x28:
; 0000 00D9 }
	RET
; .FEND
;//----------------------------------------------------------------------
;void sending_UART(void)
; 0000 00DC {
_sending_UART:
; .FSTART _sending_UART
; 0000 00DD if(gSendUartCnt==0) return;
	TST  R4
	BRNE _0x30
	RET
; 0000 00DE if((UCSRA & 0x20)==0) return;
_0x30:
	SBIS 0xB,5
	RET
; 0000 00DF UDR=gSendUartBuff[gSendUartInd];
	MOV  R30,R7
	LDI  R31,0
	SUBI R30,LOW(-_gSendUartBuff)
	SBCI R31,HIGH(-_gSendUartBuff)
	LD   R30,Z
	OUT  0xC,R30
; 0000 00E0 gSendUartInd++;
	INC  R7
; 0000 00E1 if(gSendUartInd==gSendUartCnt) gSendUartCnt=0;
	CP   R4,R7
	BRNE _0x32
	CLR  R4
; 0000 00E2 }
_0x32:
	RET
; .FEND
;//----------------------------------------------------------------------
;void send_UART(u_char type, u_char *buff, u_char cnt, u_char force)
; 0000 00E5 {
_send_UART:
; .FSTART _send_UART
; 0000 00E6 u_char crc, i;
; 0000 00E7 u_char *p;
; 0000 00E8 
; 0000 00E9 if(gSendUartCnt!=0 && force==0) return;
	ST   -Y,R26
	RCALL __SAVELOCR4
;	type -> Y+8
;	*buff -> Y+6
;	cnt -> Y+5
;	force -> Y+4
;	crc -> R17
;	i -> R16
;	*p -> R18,R19
	TST  R4
	BREQ _0x34
	LDD  R26,Y+4
	CPI  R26,LOW(0x0)
	BREQ _0x35
_0x34:
	RJMP _0x33
_0x35:
	RJMP _0x2020007
; 0000 00EA gSendUartCnt=0;
_0x33:
	CLR  R4
; 0000 00EB gSendUartInd=0;
	CLR  R7
; 0000 00EC p=gSendUartBuff;
	__POINTWRM 18,19,_gSendUartBuff
; 0000 00ED *p++=SYN_UART;
	MOVW R26,R18
	__ADDWRN 18,19,1
	LDI  R30,LOW(90)
	ST   X,R30
; 0000 00EE *p++=cnt;
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	LDD  R30,Y+5
	POP  R26
	POP  R27
	ST   X,R30
; 0000 00EF crc=cnt;
	LDD  R17,Y+5
; 0000 00F0 *p++=type;
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	LDD  R30,Y+8
	POP  R26
	POP  R27
	ST   X,R30
; 0000 00F1 crc^=type;
	EOR  R17,R30
; 0000 00F2 for(i=0; i<cnt; i++)
	LDI  R16,LOW(0)
_0x37:
	LDD  R30,Y+5
	CP   R16,R30
	BRSH _0x38
; 0000 00F3   {
; 0000 00F4   crc^=buff[i];
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	EOR  R17,R30
; 0000 00F5   *p++=buff[i];
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
; 0000 00F6   }
	SUBI R16,-1
	RJMP _0x37
_0x38:
; 0000 00F7 *p++=crc;
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	MOV  R30,R17
	POP  R26
	POP  R27
	ST   X,R30
; 0000 00F8 *p++='\r';
	MOVW R26,R18
	__ADDWRN 18,19,1
	LDI  R30,LOW(13)
	ST   X,R30
; 0000 00F9 *p='\n';
	MOVW R26,R18
	LDI  R30,LOW(10)
	ST   X,R30
; 0000 00FA gSendUartCnt=1+1+1+cnt+1+2;
	LDD  R30,Y+5
	SUBI R30,-LOW(6)
	MOV  R4,R30
; 0000 00FB }
_0x2020007:
	RCALL __LOADLOCR4
	ADIW R28,9
	RET
; .FEND
;//-----------------------------------------------------
;//-----------------------------------------------------
;//-----------------------------------------------------
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0100 { // 
_ext_int0_isr:
; .FSTART _ext_int0_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0101 u_char ind;
; 0000 0102 
; 0000 0103 if(gNumLine < long_delay) gNumLine++;
	ST   -Y,R17
;	ind -> R17
	LDI  R30,LOW(200)
	CP   R2,R30
	BRSH _0x39
	INC  R2
; 0000 0104 if(gNumLine >= START_LINE_TT)
_0x39:
	LDI  R30,LOW(24)
	CP   R2,R30
	BRLO _0x3A
; 0000 0105   {
; 0000 0106   ind=gNumLine-START_LINE_TT;
	MOV  R30,R2
	SUBI R30,LOW(24)
	MOV  R17,R30
; 0000 0107   if(ind<COUNT_LINE_TT)
	CPI  R17,2
	BRSH _0x3B
; 0000 0108     {
; 0000 0109 //  LED_ERR=1;
; 0000 010A     gVideoBuffPoint=gVideoBuff[ind];
	LDI  R26,LOW(14)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_gVideoBuff)
	SBCI R31,HIGH(-_gVideoBuff)
	__PUTW1R 5,6
; 0000 010B     GICR=0x80;  //int0 disable
	LDI  R30,LOW(128)
	OUT  0x3B,R30
; 0000 010C     MCUCR=0x8A; //sleep=enable
	LDI  R30,LOW(138)
	OUT  0x35,R30
; 0000 010D     GIFR=0xc0;  //int0, int1 flag clear
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 010E     ACSR=0x1A;  //AC_int=falling, int_flag=clear
	LDI  R30,LOW(26)
	OUT  0x8,R30
; 0000 010F     #asm("sei")
	sei
; 0000 0110     #asm("sleep") //wait AC_int
	sleep
; 0000 0111     return;
	RJMP _0xF7
; 0000 0112     }
; 0000 0113   else if(ind==COUNT_LINE_TT)
_0x3B:
	CPI  R17,2
	BRNE _0x3D
; 0000 0114     {
; 0000 0115 //    #asm("sei")
; 0000 0116     rec_v_data();
	RCALL _rec_v_data
; 0000 0117     }
; 0000 0118   }
_0x3D:
; 0000 0119 }
_0x3A:
_0xF7:
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;//-----------------------------------------------------
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 011C { // 
_ext_int1_isr:
; .FSTART _ext_int1_isr
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 011D gNumLine=0;
	CLR  R2
; 0000 011E //  ..:
; 0000 011F ACSR=0x00; //AC_int=disable
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 0120 GICR=0xC0; //int0 enable
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 0121 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
; .FEND
;//-----------------------------------------------------
;#pragma savereg-
;interrupt [ANA_COMP] void ana_comp_isr(void)
; 0000 0125 { // Data
_ana_comp_isr:
; .FSTART _ana_comp_isr
; 0000 0126 #asm
; 0000 0127     ST   -Y,R16   ;2t
    ST   -Y,R16   ;2t
; 0000 0128     ST   -Y,R17   ;2t
    ST   -Y,R17   ;2t
; 0000 0129     ST   -Y,R18   ;2t
    ST   -Y,R18   ;2t
; 0000 012A     ST   -Y,R26   ;2t
    ST   -Y,R26   ;2t
; 0000 012B     ST   -Y,R27   ;2t
    ST   -Y,R27   ;2t
; 0000 012C     IN   R16,SREG
    IN   R16,SREG
; 0000 012D     ST   -Y,R16
    ST   -Y,R16
; 0000 012E 

; 0000 012F ;    CBI  0x12,5    ;LED_ERR=0 !!!
;    CBI  0x12,5    ;LED_ERR=0 !!!
; 0000 0130 ;
;
; 0000 0131     MOV  R26,gVideoBuffPointL      ;1t
    MOV  R26,gVideoBuffPointL      ;1t
; 0000 0132     MOV  R27,gVideoBuffPointH      ;1t
    MOV  R27,gVideoBuffPointH      ;1t
; 0000 0133     LDI  R16,(BYTES_FROM_STRING-1) ;1t
    LDI  R16,(BYTES_FROM_STRING-1) ;1t
; 0000 0134 ;skeep bits
;skeep bits
; 0000 0135     LDI  R17,8
    LDI  R17,8
; 0000 0136 _wait_n:
_wait_n:
; 0000 0137     DEC  R17
    DEC  R17
; 0000 0138     NOP NOP NOP NOP NOP
    NOP NOP NOP NOP NOP
; 0000 0139     BRNE _wait_n
    BRNE _wait_n
; 0000 013A     NOP
    NOP
; 0000 013B ;add offset
;add offset
; 0000 013C     NOP
    NOP
; 0000 013D     NOP ; 
    NOP ; 
; 0000 013E     NOP  ; 
    NOP  ; 
; 0000 013F     NOP ; 
    NOP ; 
; 0000 0140 ;    NOP ; 
;    NOP ; 
; 0000 0141 ;    NOP; 
;    NOP; 
; 0000 0142     CLR  R17
    CLR  R17
; 0000 0143 _in_ch:
_in_ch:
; 0000 0144 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 0145     SBR  R17,0x10
    SBR  R17,0x10
; 0000 0146     NOP NOP NOP NOP NOP NOP
    NOP NOP NOP NOP NOP NOP
; 0000 0147 

; 0000 0148 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 0149     SBR  R17,0x20
    SBR  R17,0x20
; 0000 014A     NOP NOP NOP NOP NOP NOP
    NOP NOP NOP NOP NOP NOP
; 0000 014B 

; 0000 014C 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 014D     SBR  R17,0x40
    SBR  R17,0x40
; 0000 014E     NOP NOP NOP NOP NOP NOP
    NOP NOP NOP NOP NOP NOP
; 0000 014F 

; 0000 0150 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 0151     SBR  R17,0x80
    SBR  R17,0x80
; 0000 0152     NOP NOP NOP NOP
    NOP NOP NOP NOP
; 0000 0153     MOV  R18,R17
    MOV  R18,R17
; 0000 0154     CLR  R17
    CLR  R17
; 0000 0155 

; 0000 0156 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 0157     SBR  R17,0x1
    SBR  R17,0x1
; 0000 0158     NOP NOP NOP NOP
    NOP NOP NOP NOP
; 0000 0159     ST   X+,R18  ; 2t
    ST   X+,R18  ; 2t
; 0000 015A 

; 0000 015B 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 015C     SBR  R17,0x2
    SBR  R17,0x2
; 0000 015D     NOP NOP NOP NOP NOP NOP
    NOP NOP NOP NOP NOP NOP
; 0000 015E 

; 0000 015F 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 0160     SBR  R17,0x4
    SBR  R17,0x4
; 0000 0161     SUBI R16,1 ;1t
    SUBI R16,1 ;1t
; 0000 0162     NOP NOP NOP NOP NOP
    NOP NOP NOP NOP NOP
; 0000 0163 

; 0000 0164 	SBIS 0x8,5 ;ACSR & 0x20
	SBIS 0x8,5 ;ACSR & 0x20
; 0000 0165     SBR  R17,0x8
    SBR  R17,0x8
; 0000 0166     NOP NOP NOP NOP
    NOP NOP NOP NOP
; 0000 0167     BRSH _in_ch ;2t
    BRSH _in_ch ;2t
; 0000 0168 ;
;
; 0000 0169 	LDI  R16,LOW(0)    ;ACSR=0x0; //AC_int=disable
	LDI  R16,LOW(0)    ;ACSR=0x0; //AC_int=disable
; 0000 016A 	OUT  0x8,R16
	OUT  0x8,R16
; 0000 016B     LDI  R30,LOW(0xC0) ; int0 enable
    LDI  R30,LOW(0xC0) ; int0 enable
; 0000 016C 	OUT  0x3B,R30
	OUT  0x3B,R30
; 0000 016D 	LDI  R16,LOW(0x0A) ; MCUCR=0x0A; //sleep=disable
	LDI  R16,LOW(0x0A) ; MCUCR=0x0A; //sleep=disable
; 0000 016E 	OUT  0x35,R16
	OUT  0x35,R16
; 0000 016F 	LDI  R30,LOW(192) ; int0, int1 flag clear
	LDI  R30,LOW(192) ; int0, int1 flag clear
; 0000 0170 	OUT  0x3A,R30
	OUT  0x3A,R30
; 0000 0171     ;
    ;
; 0000 0172     LD   R16,Y+
    LD   R16,Y+
; 0000 0173     OUT  SREG,R16
    OUT  SREG,R16
; 0000 0174     LD   R27,Y+
    LD   R27,Y+
; 0000 0175     LD   R26,Y+
    LD   R26,Y+
; 0000 0176     LD   R18,Y+
    LD   R18,Y+
; 0000 0177 	LD   R17,Y+
	LD   R17,Y+
; 0000 0178     LD   R16,Y+
    LD   R16,Y+
; 0000 0179 #endasm
; 0000 017A }
	RETI
; .FEND
;#pragma savereg+
;//-----------------------------------------------------
;u_int gPPMOldVal[2];
;u_int gPPMOldMod[2];
;int abs(int n) { return n > 0 ? n : -n; }
; 0000 017F int abs(int n) { return n > 0 ? n : -n; }
_abs:
; .FSTART _abs
	ST   -Y,R27
	ST   -Y,R26
;	n -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CPW02
	BRGE _0x3E
	LD   R30,Y
	LDD  R31,Y+1
	RJMP _0x3F
_0x3E:
	LD   R30,Y
	LDD  R31,Y+1
	RCALL __ANEGW1
_0x3F:
	RJMP _0x2020001
; .FEND
;void set_ppm_out(u_char ch, u_int val)
; 0000 0181 {
_set_ppm_out:
; .FSTART _set_ppm_out
; 0000 0182 // val H 0-360
; 0000 0183 //val V=90
; 0000 0184 s_long ul;
; 0000 0185 
; 0000 0186 s_int new_val, old_val;
; 0000 0187 s_int m, y;
; 0000 0188 #define DELAY_CHANGE_PPM (10*5) //2sec
; 0000 0189 
; 0000 018A //val=180-val; // Inverted!
; 0000 018B y=(gCallibr.OutPPM_Max[ch]-gCallibr.OutPPM_Min[ch]);
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	RCALL __SAVELOCR6
;	ch -> Y+14
;	val -> Y+12
;	ul -> Y+8
;	new_val -> R16,R17
;	old_val -> R18,R19
;	m -> R20,R21
;	y -> Y+6
	__POINTW2MN _gCallibr,4
	LDD  R30,Y+14
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	LDD  R30,Y+14
	LDI  R26,LOW(_gCallibr)
	LDI  R27,HIGH(_gCallibr)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	MOVW R26,R0
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+6,R26
	STD  Y+6+1,R27
; 0000 018C ul=y; ul*=val;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __CWD1
	__PUTD1S 8
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	__GETD2S 8
	CLR  R22
	CLR  R23
	RCALL __MULD12
	__PUTD1S 8
; 0000 018D 
; 0000 018E if(ch==0){
	LDD  R30,Y+14
	CPI  R30,0
	BRNE _0x41
; 0000 018F //    val=360-val;   reverce
; 0000 0190     if(mode_360_ram){
	LDS  R30,_mode_360_ram
	CPI  R30,0
	BREQ _0x42
; 0000 0191         new_val=(s_int)(ul/360);
	__GETD2S 8
	__GETD1N 0x168
	RJMP _0xF1
; 0000 0192     }
; 0000 0193     else{
_0x42:
; 0000 0194         new_val=(s_int)(ul/180);
	__GETD2S 8
	__GETD1N 0xB4
_0xF1:
	RCALL __DIVD21
	MOVW R16,R30
; 0000 0195     }
; 0000 0196 
; 0000 0197     new_val+=gCallibr.OutPPM_Min[ch];
	RJMP _0xF2
; 0000 0198 }
; 0000 0199 else{
_0x41:
; 0000 019A 
; 0000 019B     if(mode_360_ram){
	LDS  R30,_mode_360_ram
	CPI  R30,0
	BREQ _0x45
; 0000 019C          new_val=(s_int)(ul/90); //  360      - 90 
	__GETD2S 8
	__GETD1N 0x5A
	RJMP _0xF3
; 0000 019D     }else{
_0x45:
; 0000 019E          new_val=(s_int)(ul/180); //  180      - 180 
	__GETD2S 8
	__GETD1N 0xB4
_0xF3:
	RCALL __DIVD21
	MOVW R16,R30
; 0000 019F     }
; 0000 01A0     new_val+=gCallibr.OutPPM_Min[ch];
_0xF2:
	LDD  R30,Y+14
	LDI  R26,LOW(_gCallibr)
	LDI  R27,HIGH(_gCallibr)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	__ADDWRR 16,17,30,31
; 0000 01A1 }
; 0000 01A2 
; 0000 01A3 y=abs(y);
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _abs
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 01A4 old_val=gPPMOldVal[ch];
	LDD  R30,Y+14
	LDI  R26,LOW(_gPPMOldVal)
	LDI  R27,HIGH(_gPPMOldVal)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R18,X+
	LD   R19,X
; 0000 01A5 if(old_val==new_val) return;
	__CPWRR 16,17,18,19
	BRNE _0x47
	RJMP _0x2020006
; 0000 01A6 m=gPPMOldMod[ch];
_0x47:
	LDD  R30,Y+14
	LDI  R26,LOW(_gPPMOldMod)
	LDI  R27,HIGH(_gPPMOldMod)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R20,X+
	LD   R21,X
; 0000 01A7 if(old_val<new_val) m+=y; else m-=y;
	__CPWRR 18,19,16,17
	BRGE _0x48
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	__ADDWRR 20,21,30,31
	RJMP _0x49
_0x48:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	__SUBWRR 20,21,26,27
; 0000 01A8 y=(m/DELAY_CHANGE_PPM);
_0x49:
	MOVW R26,R20
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __DIVW21
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 01A9 m-=(y*DELAY_CHANGE_PPM);
	LDI  R26,LOW(50)
	LDI  R27,HIGH(50)
	RCALL __MULW12
	__SUBWRR 20,21,30,31
; 0000 01AA gPPMOldMod[ch]=m;
	LDD  R30,Y+14
	LDI  R26,LOW(_gPPMOldMod)
	LDI  R27,HIGH(_gPPMOldMod)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R20
	STD  Z+1,R21
; 0000 01AB y+=old_val;
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 01AC if(old_val<new_val && y>new_val);
	__CPWRR 18,19,16,17
	BRGE _0x4B
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R16,R26
	CPC  R17,R27
	BRLT _0x4C
_0x4B:
	RJMP _0x4A
_0x4C:
; 0000 01AD else if(old_val>new_val && y<new_val);
	RJMP _0x4D
_0x4A:
	__CPWRR 16,17,18,19
	BRGE _0x4F
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R16
	CPC  R27,R17
	BRLT _0x50
_0x4F:
	RJMP _0x4E
_0x50:
; 0000 01AE else new_val=y;
	RJMP _0x51
_0x4E:
	__GETWRS 16,17,6
; 0000 01AF gPPMOldVal[ch]=new_val;
_0x51:
_0x4D:
	LDD  R30,Y+14
	LDI  R26,LOW(_gPPMOldVal)
	LDI  R27,HIGH(_gPPMOldVal)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
	STD  Z+1,R17
; 0000 01B0 if(ch==0) { OCR1AH=(new_val>>8); OCR1AL=(u_char)new_val; }
	LDD  R30,Y+14
	CPI  R30,0
	BRNE _0x52
	MOVW R30,R16
	RCALL __ASRW8
	OUT  0x2B,R30
	OUT  0x2A,R16
; 0000 01B1 else      { OCR1BH=(new_val>>8); OCR1BL=(u_char)new_val; }
	RJMP _0x53
_0x52:
	MOVW R30,R16
	RCALL __ASRW8
	OUT  0x29,R30
	OUT  0x28,R16
_0x53:
; 0000 01B2 }
_0x2020006:
	RCALL __LOADLOCR6
	ADIW R28,15
	RET
; .FEND
;//----------------------------------------------------------------------
;void CalcTrackPos(void)
; 0000 01B5 {
_CalcTrackPos:
; .FSTART _CalcTrackPos
; 0000 01B6 u_int angle;
; 0000 01B7 u_int Azimuth, Elevation;
; 0000 01B8 
; 0000 01B9 angle=gTrack_azimuth;
	RCALL __SAVELOCR6
;	angle -> R16,R17
;	Azimuth -> R18,R19
;	Elevation -> R20,R21
	MOVW R16,R8
; 0000 01BA 
; 0000 01BB angle+=gOff_azimuth;
	__ADDWRR 16,17,12,13
; 0000 01BC //angle=0;
; 0000 01BD if(angle>=360) {
	__CPWRN 16,17,360
	BRLO _0x54
; 0000 01BE     angle= angle % 360;
	MOVW R26,R16
	LDI  R30,LOW(360)
	LDI  R31,HIGH(360)
	RCALL __MODW21U
	MOVW R16,R30
; 0000 01BF }
; 0000 01C0 
; 0000 01C1 if((angle>180) && (!mode_360_ram))
_0x54:
	__CPWRN 16,17,181
	BRLO _0x56
	LDS  R30,_mode_360_ram
	CPI  R30,0
	BREQ _0x57
_0x56:
	RJMP _0x55
_0x57:
; 0000 01C2 {
; 0000 01C3 // 180  - " "
; 0000 01C4   Azimuth=(angle-180);
	MOVW R30,R16
	SUBI R30,LOW(180)
	SBCI R31,HIGH(180)
	MOVW R18,R30
; 0000 01C5   Elevation=(180-gTrack_elevation);
	LDI  R30,LOW(180)
	SUB  R30,R11
	MOV  R20,R30
	RJMP _0xF4
; 0000 01C6 }
; 0000 01C7 else
_0x55:
; 0000 01C8 {
; 0000 01C9     Azimuth= angle;
	MOVW R18,R16
; 0000 01CA     Elevation=gTrack_elevation;
	MOV  R20,R11
_0xF4:
	CLR  R21
; 0000 01CB }
; 0000 01CC 
; 0000 01CD gHostData.Track_azimuth=Azimuth;
	__PUTWMRN _gHostData,0,18,19
; 0000 01CE gHostData.Track_elevation=Elevation;
	__PUTWMRN _gHostData,2,20,21
; 0000 01CF set_ppm_out(0, Azimuth);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOVW R26,R18
	RCALL _set_ppm_out
; 0000 01D0 set_ppm_out(1, Elevation);
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R26,R20
	RCALL _set_ppm_out
; 0000 01D1 }
_0x2020005:
	RCALL __LOADLOCR6
	ADIW R28,6
	RET
; .FEND
;
;void send_chanel_ppm(u_char ch, u_int new_val){
; 0000 01D3 void send_chanel_ppm(unsigned char  ch, unsigned int  new_val){
_send_chanel_ppm:
; .FSTART _send_chanel_ppm
; 0000 01D4     if(ch==0) { OCR1AH=(new_val>>8); OCR1AL=(u_char)new_val; }
	ST   -Y,R27
	ST   -Y,R26
;	ch -> Y+2
;	new_val -> Y+0
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x59
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	OUT  0x2B,R30
	LD   R30,Y
	OUT  0x2A,R30
; 0000 01D5     else      { OCR1BH=(new_val>>8); OCR1BL=(u_char)new_val; }
	RJMP _0x5A
_0x59:
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	OUT  0x29,R30
	LD   R30,Y
	OUT  0x28,R30
_0x5A:
; 0000 01D6 }
	RJMP _0x2020004
; .FEND
;
;void blinker(u_char blink_encounter,u_char mode){
; 0000 01D8 void blinker(unsigned char  blink_encounter,unsigned char  mode){
_blinker:
; .FSTART _blinker
; 0000 01D9     u_char half_delay;
; 0000 01DA     half_delay=blink_delay >> 1;
	ST   -Y,R26
	ST   -Y,R17
;	blink_encounter -> Y+2
;	mode -> Y+1
;	half_delay -> R17
	LDI  R17,LOW(12)
; 0000 01DB     if((blink_encounter % blink_delay) <= half_delay ){
	LDD  R26,Y+2
	LDI  R30,LOW(25)
	RCALL __MODB21U
	CP   R17,R30
	BRLO _0x5B
; 0000 01DC         switch(mode){
	LDD  R30,Y+1
; 0000 01DD             case 0:
	CPI  R30,0
	BRNE _0x5F
; 0000 01DE                 LED_ERR=1;
	SBI  0x12,5
; 0000 01DF                 break;
	RJMP _0x5E
; 0000 01E0             case 1:
_0x5F:
	CPI  R30,LOW(0x1)
	BRNE _0x62
; 0000 01E1                 LED_LowBat=1;
	SBI  0x18,0
; 0000 01E2                 break;
	RJMP _0x5E
; 0000 01E3             case 2:
_0x62:
	CPI  R30,LOW(0x2)
	BRNE _0x65
; 0000 01E4                 LED_RSSI=1;
	SBI  0x18,3
; 0000 01E5                 break;
	RJMP _0x5E
; 0000 01E6             case 3:
_0x65:
	CPI  R30,LOW(0x3)
	BRNE _0x68
; 0000 01E7                 LED_ERR=1;
	SBI  0x12,5
; 0000 01E8                 LED_LowBat=1;
	SBI  0x18,0
; 0000 01E9                 break;
	RJMP _0x5E
; 0000 01EA             case 4:
_0x68:
	CPI  R30,LOW(0x4)
	BRNE _0x74
; 0000 01EB                 LED_ERR=1;
	SBI  0x12,5
; 0000 01EC                 LED_LowBat=1;
	SBI  0x18,0
; 0000 01ED                 LED_RSSI=1;
	SBI  0x18,3
; 0000 01EE                 break;
; 0000 01EF             default:
_0x74:
; 0000 01F0         }
_0x5E:
; 0000 01F1 
; 0000 01F2     }else{
	RJMP _0x75
_0x5B:
; 0000 01F3         LED_ERR=0;
	CBI  0x12,5
; 0000 01F4         LED_LowBat=0;
	CBI  0x18,0
; 0000 01F5         LED_RSSI=0;
	CBI  0x18,3
; 0000 01F6     }
_0x75:
; 0000 01F7 }
	LDD  R17,Y+0
_0x2020004:
	ADIW R28,3
	RET
; .FEND
;
;s_char ask_keys(void){
; 0000 01F9 signed char ask_keys(void){
_ask_keys:
; .FSTART _ask_keys
; 0000 01FA     if(!IN_KEY && !IN_KEY_1) return 0;
	SBIC 0x16,4
	RJMP _0x7D
	SBIS 0x13,3
	RJMP _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
	RJMP _0x2020003
; 0000 01FB     if(!IN_KEY) return 1;
_0x7C:
	SBIC 0x16,4
	RJMP _0x7F
	LDI  R30,LOW(1)
	RET
; 0000 01FC     if(!IN_KEY_1) return -1;
_0x7F:
	SBIC 0x13,3
	RJMP _0x80
	LDI  R30,LOW(255)
	RET
; 0000 01FD     return 0;
_0x80:
_0x2020003:
	LDI  R30,LOW(0)
	RET
; 0000 01FE }
; .FEND
;
;u_int check_servo_limit_mid(u_int servo_value){
; 0000 0200 unsigned int  check_servo_limit_mid(unsigned int  servo_value){
_check_servo_limit_mid:
; .FSTART _check_servo_limit_mid
; 0000 0201 //          .
; 0000 0202     if( servo_value < servo_min_limit || servo_value > servo_max_limit){
	ST   -Y,R27
	ST   -Y,R26
;	servo_value -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x5DC)
	LDI  R30,HIGH(0x5DC)
	CPC  R27,R30
	BRLO _0x82
	CPI  R26,LOW(0x1771)
	LDI  R30,HIGH(0x1771)
	CPC  R27,R30
	BRLO _0x81
_0x82:
; 0000 0203 
; 0000 0204         return 3750; //   
	LDI  R30,LOW(3750)
	LDI  R31,HIGH(3750)
	RJMP _0x2020001
; 0000 0205     }
; 0000 0206     return servo_value;
_0x81:
	RJMP _0x2020002
; 0000 0207 }
; .FEND
;
;u_int check_servo_limit(u_int servo_value){
; 0000 0209 unsigned int  check_servo_limit(unsigned int  servo_value){
_check_servo_limit:
; .FSTART _check_servo_limit
; 0000 020A //      .
; 0000 020B     if( servo_value < servo_min_limit){
	ST   -Y,R27
	ST   -Y,R26
;	servo_value -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x5DC)
	LDI  R30,HIGH(0x5DC)
	CPC  R27,R30
	BRSH _0x84
; 0000 020C         BUZ_1=1; // ;
	SBI  0x12,4
; 0000 020D         return servo_min_limit;
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	RJMP _0x2020001
; 0000 020E     }
; 0000 020F 
; 0000 0210      if( servo_value > servo_max_limit){
_0x84:
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x1771)
	LDI  R30,HIGH(0x1771)
	CPC  R27,R30
	BRLO _0x87
; 0000 0211         BUZ_1=1; // ;
	SBI  0x12,4
; 0000 0212         return servo_max_limit;
	LDI  R30,LOW(6000)
	LDI  R31,HIGH(6000)
	RJMP _0x2020001
; 0000 0213     }
; 0000 0214 
; 0000 0215     return servo_value;
_0x87:
_0x2020002:
	LD   R30,Y
	LDD  R31,Y+1
_0x2020001:
	ADIW R28,2
	RET
; 0000 0216 }
; .FEND
;//-----------------------------------------------------
;void main(void)
; 0000 0219 {
_main:
; .FSTART _main
; 0000 021A u_char i, div1, div2,div_prog, wr_wait, prog_mode, old_prog_mode, div_blink;
; 0000 021B u_int  prog_wait;
; 0000 021C 
; 0000 021D // Input/Output Ports initialization
; 0000 021E // Port B initialization
; 0000 021F // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0220 // State7=T State6=T State5=P State4=P State3=0 State2=0 State1=0 State0=0
; 0000 0221 PORTB=0x30;
	SBIW R28,4
;	i -> R17
;	div1 -> R16
;	div2 -> R19
;	div_prog -> R18
;	wr_wait -> R21
;	prog_mode -> R20
;	old_prog_mode -> Y+3
;	div_blink -> Y+2
;	prog_wait -> Y+0
	LDI  R30,LOW(48)
	OUT  0x18,R30
; 0000 0222 DDRB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x17,R30
; 0000 0223 // Port C initialization
; 0000 0224 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0225 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0226 PORTC=0x08;
	LDI  R30,LOW(8)
	OUT  0x15,R30
; 0000 0227 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 0228 // Port D initialization
; 0000 0229 // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In
; 0000 022A // State7=T State6=T State5=0 State4=0 State3=T State2=T State1=0 State0=T
; 0000 022B PORTD=0x00;
	OUT  0x12,R30
; 0000 022C DDRD=0x32;
	LDI  R30,LOW(50)
	OUT  0x11,R30
; 0000 022D // Timer/Counter 0; main loop period
; 0000 022E // Clock source: System Clock
; 0000 022F // Clock value: 312,500 kHz
; 0000 0230 TCCR0=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 0231 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0232 // Timer/Counter 1; servo-PWM generation
; 0000 0233 // Clock source: System Clock
; 0000 0234 // Clock value: 2500,000 kHz
; 0000 0235 // Mode: Fast PWM top=ICR1
; 0000 0236 // OC1A output: Non-Inv.
; 0000 0237 // OC1B output: Non-Inv.
; 0000 0238 // Noise Canceler: Off
; 0000 0239 // Input Capture on Falling Edge
; 0000 023A // Timer 1 Overflow Interrupt: Off
; 0000 023B // Input Capture Interrupt: Off
; 0000 023C // Compare A Match Interrupt: Off
; 0000 023D // Compare B Match Interrupt: Off
; 0000 023E 
; 0000 023F 
; 0000 0240 
; 0000 0241 TCCR1A=0xA2;
	LDI  R30,LOW(162)
	OUT  0x2F,R30
; 0000 0242 TCCR1B=0x1A;
	LDI  R30,LOW(26)
	OUT  0x2E,R30
; 0000 0243 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0244 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0245 
; 0000 0246 
; 0000 0247 
; 0000 0248 ICR1H=HIGH(200*250);
	LDI  R30,LOW(195)
	OUT  0x27,R30
; 0000 0249 ICR1L=LOW(200*250);
	LDI  R30,LOW(80)
	OUT  0x26,R30
; 0000 024A 
; 0000 024B delay_ms(5000);
	LDI  R26,LOW(5000)
	LDI  R27,HIGH(5000)
	RCALL _delay_ms
; 0000 024C 
; 0000 024D OCR1AH=HIGH(15*250);
	LDI  R30,LOW(14)
	OUT  0x2B,R30
; 0000 024E OCR1AL=LOW(15*250);
	LDI  R30,LOW(166)
	OUT  0x2A,R30
; 0000 024F OCR1BH=HIGH(15*250);
	LDI  R30,LOW(14)
	OUT  0x29,R30
; 0000 0250 OCR1BL=LOW(15*250);
	LDI  R30,LOW(166)
	OUT  0x28,R30
; 0000 0251 for(i=0; i<2; i++)  { gPPMOldVal[i]=(15*250); gPPMOldMod[i]=0; }
	LDI  R17,LOW(0)
_0x8B:
	CPI  R17,2
	BRSH _0x8C
	MOV  R30,R17
	LDI  R26,LOW(_gPPMOldVal)
	LDI  R27,HIGH(_gPPMOldVal)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(3750)
	LDI  R31,HIGH(3750)
	ST   X+,R30
	ST   X,R31
	MOV  R30,R17
	LDI  R26,LOW(_gPPMOldMod)
	LDI  R27,HIGH(_gPPMOldMod)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	SUBI R17,-1
	RJMP _0x8B
_0x8C:
; 0000 0252 // Timer/Counter 2; not used
; 0000 0253 // Clock source: System Clock
; 0000 0254 // Clock value: 2500,000 kHz
; 0000 0255 // Mode: CTC top=OCR2
; 0000 0256 // OC2 output: Disconnected
; 0000 0257 ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x22,R30
; 0000 0258 TCCR2=0x0A;
	LDI  R30,LOW(10)
	OUT  0x25,R30
; 0000 0259 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 025A OCR2=160;//159; // 64mks
	LDI  R30,LOW(160)
	OUT  0x23,R30
; 0000 025B // External Interrupt(s) initialization
; 0000 025C // INT0: On
; 0000 025D // INT0 Mode: Falling Edge
; 0000 025E // INT1: On
; 0000 025F // INT1 Mode: Falling Edge
; 0000 0260 GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 0261 MCUCR=0x0A;
	LDI  R30,LOW(10)
	OUT  0x35,R30
; 0000 0262 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 0263 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0264 TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 0265 // USART initialization
; 0000 0266 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0267 // USART Receiver: On
; 0000 0268 // USART Transmitter: On
; 0000 0269 // USART Mode: Asynchronous
; 0000 026A // USART Baud Rate: 38400
; 0000 026B UCSRA=0x00;
	OUT  0xB,R30
; 0000 026C UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
; 0000 026D UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 026E UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 026F UBRRL=0x20;
	LDI  R30,LOW(32)
	OUT  0x9,R30
; 0000 0270 // Analog Comparator initialization
; 0000 0271 ACSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 0272 SFIOR=0x00;
	OUT  0x30,R30
; 0000 0273 // ADC initialization
; 0000 0274 // ADC Clock frequency: 625,000 kHz
; 0000 0275 ADMUX=ADC_VREF_TYPE;
	LDI  R30,LOW(64)
	OUT  0x7,R30
; 0000 0276 ADCSRA=0x85;
	LDI  R30,LOW(133)
	OUT  0x6,R30
; 0000 0277 
; 0000 0278 //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 0279 //!!!!!!!!!!!!!!!!!  !!!!!!!!!!!!!!!!!!!
; 0000 027A //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 027B // ,       
; 0000 027C // : K=T(ms)*2500;    
; 0000 027D // 3750 1.5ms -- mid
; 0000 027E // ..   1ms K=1ms*2500=2500;
; 0000 027F //                0.8ms K=0.8*2500=2000;
; 0000 0280 //for(i=0; i<2; i++)
; 0000 0281 //  {
; 0000 0282 //  gCallibr.OutPPM_Min[i]=(100*25); // 1ms
; 0000 0283 //  gCallibr.OutPPM_Max[i]=(200*25); // 2ms
; 0000 0284 //  }
; 0000 0285 //      .   .
; 0000 0286 //   ,         :
; 0000 0287 // 
; 0000 0288 /*
; 0000 0289 gCallibr.OutPPM_Min[0]=(2763); // 1,08ms
; 0000 028A gCallibr.OutPPM_Max[0]=(4737); // 1,9ms
; 0000 028B // 
; 0000 028C gCallibr.OutPPM_Min[1]=(2500); // 1,04ms
; 0000 028D gCallibr.OutPPM_Max[1]=(4975); // 1,95ms
; 0000 028E */
; 0000 028F //         .. :)
; 0000 0290 //--------------------------------------------------------------------
; 0000 0291 //  : 1,08 - 1,9 -     1,04 - 1,95 - 
; 0000 0292 //----------------------------------------------------------------------
; 0000 0293 
; 0000 0294 //   
; 0000 0295 
; 0000 0296 
; 0000 0297 gCallibr.OutPPM_Min[0]=check_servo_limit_mid(EEP_azimuth_min_limit);
	LDI  R26,LOW(_EEP_azimuth_min_limit)
	LDI  R27,HIGH(_EEP_azimuth_min_limit)
	RCALL __EEPROMRDW
	MOVW R26,R30
	RCALL _check_servo_limit_mid
	STS  _gCallibr,R30
	STS  _gCallibr+1,R31
; 0000 0298 gCallibr.OutPPM_Max[0]=check_servo_limit_mid(EEP_azimuth_max_limit);
	LDI  R26,LOW(_EEP_azimuth_max_limit)
	LDI  R27,HIGH(_EEP_azimuth_max_limit)
	RCALL __EEPROMRDW
	MOVW R26,R30
	RCALL _check_servo_limit_mid
	__PUTW1MN _gCallibr,4
; 0000 0299 gCallibr.OutPPM_Min[1]=check_servo_limit_mid(EEP_elevation_min_limit);
	LDI  R26,LOW(_EEP_elevation_min_limit)
	LDI  R27,HIGH(_EEP_elevation_min_limit)
	RCALL __EEPROMRDW
	MOVW R26,R30
	RCALL _check_servo_limit_mid
	__PUTW1MN _gCallibr,2
; 0000 029A gCallibr.OutPPM_Max[1]=check_servo_limit_mid(EEP_elevation_max_limit);
	LDI  R26,LOW(_EEP_elevation_max_limit)
	LDI  R27,HIGH(_EEP_elevation_max_limit)
	RCALL __EEPROMRDW
	MOVW R26,R30
	RCALL _check_servo_limit_mid
	__PUTW1MN _gCallibr,6
; 0000 029B mode_360_ram = EEP_mode360;
	LDI  R26,LOW(_EEP_mode360)
	LDI  R27,HIGH(_EEP_mode360)
	RCALL __EEPROMRDB
	STS  _mode_360_ram,R30
; 0000 029C 
; 0000 029D gNumLine=0;
	CLR  R2
; 0000 029E gVideoBuffPoint=gVideoBuff[0];
	LDI  R30,LOW(_gVideoBuff)
	LDI  R31,HIGH(_gVideoBuff)
	__PUTW1R 5,6
; 0000 029F div1=0; div2=0; wr_wait=0; prog_wait=0;
	LDI  R16,LOW(0)
	LDI  R19,LOW(0)
	LDI  R21,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 02A0 div_prog=0;prog_mode=0; div_blink=0;
	LDI  R18,LOW(0)
	LDI  R20,LOW(0)
	STD  Y+2,R30
; 0000 02A1 
; 0000 02A2 gTrack_azimuth=0;
	CLR  R8
	CLR  R9
; 0000 02A3 gTrack_elevation=0;
	CLR  R11
; 0000 02A4 if(EEP_Off_azimuth>=360){
	LDI  R26,LOW(_EEP_Off_azimuth)
	LDI  R27,HIGH(_EEP_Off_azimuth)
	RCALL __EEPROMRDW
	CPI  R30,LOW(0x168)
	LDI  R26,HIGH(0x168)
	CPC  R31,R26
	BRLO _0x8D
; 0000 02A5     EEP_Off_azimuth=EEP_Off_azimuth % 360;
	LDI  R26,LOW(_EEP_Off_azimuth)
	LDI  R27,HIGH(_EEP_Off_azimuth)
	RCALL __EEPROMRDW
	MOVW R26,R30
	LDI  R30,LOW(360)
	LDI  R31,HIGH(360)
	RCALL __MODW21U
	LDI  R26,LOW(_EEP_Off_azimuth)
	LDI  R27,HIGH(_EEP_Off_azimuth)
	RCALL __EEPROMWRW
; 0000 02A6 }
; 0000 02A7 gOff_azimuth=EEP_Off_azimuth;
_0x8D:
	LDI  R26,LOW(_EEP_Off_azimuth)
	LDI  R27,HIGH(_EEP_Off_azimuth)
	RCALL __EEPROMRDW
	MOVW R12,R30
; 0000 02A8 // testing leds
; 0000 02A9 delay_ms(150);
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02AA BUZ_1=1; LED_ERR=1;
	SBI  0x12,4
	SBI  0x12,5
; 0000 02AB delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02AC BUZ_1=0; LED_ERR=0;
	CBI  0x12,4
	CBI  0x12,5
; 0000 02AD delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02AE BUZ_1=1; BUZ_1=1;
	SBI  0x12,4
	SBI  0x12,4
; 0000 02AF delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02B0 BUZ_1=0; BUZ_1=0;
	CBI  0x12,4
	CBI  0x12,4
; 0000 02B1 delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02B2 LED_LowBat=1; BUZ_2=1;
	SBI  0x18,0
	SBI  0x18,3
; 0000 02B3 delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02B4 LED_LowBat=0; BUZ_2=0;
	CBI  0x18,0
	CBI  0x18,3
; 0000 02B5 delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02B6 LED_LowBat=1; BUZ_2=1;
	SBI  0x18,0
	SBI  0x18,3
; 0000 02B7 delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02B8 LED_LowBat=0; BUZ_2=0;
	CBI  0x18,0
	CBI  0x18,3
; 0000 02B9 delay_ms(150);
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02BA //
; 0000 02BB //ff=0;
; 0000 02BC 
; 0000 02BD 
; 0000 02BE 
; 0000 02BF #asm("sei")
	sei
; 0000 02C0 while(1)
_0xAE:
; 0000 02C1   {
; 0000 02C2   i=TCNT0;  //period CNT0 (1000/312500)*256=0.82ms
	IN   R17,50
; 0000 02C3   if(i<gOldCnt0) gCCNT0++;
	LDS  R30,_gOldCnt0
	CP   R17,R30
	BRSH _0xB1
	LDS  R30,_gCCNT0
	SUBI R30,-LOW(1)
	STS  _gCCNT0,R30
; 0000 02C4   gOldCnt0=i;
_0xB1:
	STS  _gOldCnt0,R17
; 0000 02C5   if(gCCNT0 > short_delay){ //20.5ms
	LDS  R26,_gCCNT0
	CPI  R26,LOW(0x1A)
	BRSH PC+2
	RJMP _0xB2
; 0000 02C6 
; 0000 02C7         gCCNT0=0;
	LDI  R30,LOW(0)
	STS  _gCCNT0,R30
; 0000 02C8 
; 0000 02C9         if (prog_wait < long_delay){
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0xC8)
	LDI  R30,HIGH(0xC8)
	CPC  R27,R30
	BRLO PC+2
	RJMP _0xB3
; 0000 02CA 
; 0000 02CB             if(!IN_KEY && !IN_KEY_1){
	SBIC 0x16,4
	RJMP _0xB5
	SBIS 0x13,3
	RJMP _0xB6
_0xB5:
	RJMP _0xB4
_0xB6:
; 0000 02CC                  set_ppm_out(0, 180); //  
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(180)
	LDI  R27,0
	RCALL _set_ppm_out
; 0000 02CD                  set_ppm_out(1, 0); //  
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(0)
	LDI  R27,0
	RCALL _set_ppm_out
; 0000 02CE                  prog_wait++;  //   
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
; 0000 02CF                  BUZ_1=0; // 
	CBI  0x12,4
; 0000 02D0                  continue;
	RJMP _0xAE
; 0000 02D1             }
; 0000 02D2 
; 0000 02D3             prog_wait=0; //     
_0xB4:
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 02D4 
; 0000 02D5             if(!IN_KEY) {
	SBIC 0x16,4
	RJMP _0xB9
; 0000 02D6                  wr_wait=1;
	LDI  R21,LOW(1)
; 0000 02D7                  if(++gOff_azimuth>=360){
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
	CPI  R30,LOW(0x168)
	LDI  R26,HIGH(0x168)
	CPC  R31,R26
	BRLO _0xBA
; 0000 02D8                       gOff_azimuth=0;
	CLR  R12
	CLR  R13
; 0000 02D9                  }
; 0000 02DA             }
_0xBA:
; 0000 02DB 
; 0000 02DC             if(!IN_KEY_1) {
_0xB9:
	SBIC 0x13,3
	RJMP _0xBB
; 0000 02DD                 wr_wait=1;
	LDI  R21,LOW(1)
; 0000 02DE                 if(--gOff_azimuth<=0 || gOff_azimuth>359){
	MOVW R30,R12
	SBIW R30,1
	MOVW R12,R30
	RCALL __CPW01
	BRSH _0xBD
	LDI  R30,LOW(359)
	LDI  R31,HIGH(359)
	CP   R30,R12
	CPC  R31,R13
	BRSH _0xBC
_0xBD:
; 0000 02DF                      gOff_azimuth=359;
	LDI  R30,LOW(359)
	LDI  R31,HIGH(359)
	MOVW R12,R30
; 0000 02E0                 }
; 0000 02E1             }
_0xBC:
; 0000 02E2 
; 0000 02E3             if(wr_wait){
_0xBB:
	CPI  R21,0
	BREQ _0xBF
; 0000 02E4                 if(++wr_wait== long_delay ) {
	SUBI R21,-LOW(1)
	CPI  R21,200
	BRNE _0xC0
; 0000 02E5                      wr_wait=0;
	LDI  R21,LOW(0)
; 0000 02E6                     EEP_Off_azimuth=gOff_azimuth;
	MOVW R30,R12
	LDI  R26,LOW(_EEP_Off_azimuth)
	LDI  R27,HIGH(_EEP_Off_azimuth)
	RCALL __EEPROMWRW
; 0000 02E7                 }
; 0000 02E8             }
_0xC0:
; 0000 02E9 
; 0000 02EA             GetAVErrors();
_0xBF:
	RCALL _GetAVErrors
; 0000 02EB             GetAV_RSSI();
	RCALL _GetAV_RSSI
; 0000 02EC 
; 0000 02ED             if(++div1>=5){
	SUBI R16,-LOW(1)
	CPI  R16,5
	BRLO _0xC1
; 0000 02EE                 div1=0;
	LDI  R16,LOW(0)
; 0000 02EF                 f_flash^=1;
	LDI  R30,LOW(1)
	EOR  R10,R30
; 0000 02F0                 if(++div2>=5){
	SUBI R19,-LOW(1)
	CPI  R19,5
	BRLO _0xC2
; 0000 02F1                     div2=0;
	LDI  R19,LOW(0)
; 0000 02F2                     if(gHostData.AVErrors>50){
	__GETB2MN _gHostData,14
	CPI  R26,LOW(0x33)
	BRLO _0xC3
; 0000 02F3                         BUZ_1=1;
	SBI  0x12,4
; 0000 02F4                     }
; 0000 02F5                 }
_0xC3:
; 0000 02F6                 else BUZ_1=0;
	RJMP _0xC6
_0xC2:
	CBI  0x12,4
; 0000 02F7             }
_0xC6:
; 0000 02F8 //    if(ff==0)
; 0000 02F9             send_UART(0, (u_char *)&gHostData, sizeof(TO_HOST_DATA), 1);
_0xC1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(_gHostData)
	LDI  R31,HIGH(_gHostData)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _send_UART
; 0000 02FA //    else send_UART(ff , gVideoBuff[ff-1] ,12, 1);
; 0000 02FB //    if(++ff>2) ff=0;
; 0000 02FC             CalcTrackPos();
	RCALL _CalcTrackPos
; 0000 02FD         }else{  //Programming Mode
	RJMP _0xC9
_0xB3:
; 0000 02FE             if(div_prog < programm_buzz_delay){  //Song Beep about Programming
	CPI  R18,50
	BRSH _0xCA
; 0000 02FF                 BUZ_1=1;
	SBI  0x12,4
; 0000 0300                 div_prog++;
	SUBI R18,-1
; 0000 0301             } else{
	RJMP _0xCD
_0xCA:
; 0000 0302                   BUZ_1=0;
	CBI  0x12,4
; 0000 0303             }
_0xCD:
; 0000 0304 
; 0000 0305 
; 0000 0306             old_prog_mode = prog_mode;
	__PUTBSR 20,3
; 0000 0307             if(!IN_KEY && !IN_KEY_1){
	SBIC 0x16,4
	RJMP _0xD1
	SBIS 0x13,3
	RJMP _0xD2
_0xD1:
	RJMP _0xD0
_0xD2:
; 0000 0308                  prog_wait++;  //   
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	RJMP _0xF5
; 0000 0309             }else{
_0xD0:
; 0000 030A                  prog_wait= (int) long_delay + (int)prog_mode * change_mode_delay; //   
	LDI  R30,LOW(50)
	MUL  R30,R20
	MOVW R30,R0
	SUBI R30,LOW(-200)
	SBCI R31,HIGH(-200)
_0xF5:
	ST   Y,R30
	STD  Y+1,R31
; 0000 030B             }
; 0000 030C 
; 0000 030D             prog_mode = (u_int) (prog_wait - long_delay)/change_mode_delay; //   
	LD   R26,Y
	LDD  R27,Y+1
	SUBI R26,LOW(200)
	SBCI R27,HIGH(200)
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __DIVW21U
	MOV  R20,R30
; 0000 030E 
; 0000 030F             if( old_prog_mode != prog_mode){
	LDD  R26,Y+3
	CP   R20,R26
	BREQ _0xD4
; 0000 0310                  div_prog=0; // Song Beep
	LDI  R18,LOW(0)
; 0000 0311                  if(prog_mode>4){
	CPI  R20,5
	BRLO _0xD5
; 0000 0312                     prog_wait=0;//    
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 0313                     blinker(blink_delay-1,0); //  
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _blinker
; 0000 0314                     //    
; 0000 0315 
; 0000 0316                     EEP_azimuth_min_limit = gCallibr.OutPPM_Min[0];
	LDS  R30,_gCallibr
	LDS  R31,_gCallibr+1
	LDI  R26,LOW(_EEP_azimuth_min_limit)
	LDI  R27,HIGH(_EEP_azimuth_min_limit)
	RCALL __EEPROMWRW
; 0000 0317                     EEP_azimuth_max_limit = gCallibr.OutPPM_Max[0];
	__GETW1MN _gCallibr,4
	LDI  R26,LOW(_EEP_azimuth_max_limit)
	LDI  R27,HIGH(_EEP_azimuth_max_limit)
	RCALL __EEPROMWRW
; 0000 0318                     EEP_elevation_min_limit = gCallibr.OutPPM_Min[1];
	__GETW1MN _gCallibr,2
	LDI  R26,LOW(_EEP_elevation_min_limit)
	LDI  R27,HIGH(_EEP_elevation_min_limit)
	RCALL __EEPROMWRW
; 0000 0319                     EEP_elevation_max_limit = gCallibr.OutPPM_Max[1];
	__GETW1MN _gCallibr,6
	LDI  R26,LOW(_EEP_elevation_max_limit)
	LDI  R27,HIGH(_EEP_elevation_max_limit)
	RCALL __EEPROMWRW
; 0000 031A                     EEP_mode360 = mode_360_ram;
	LDS  R30,_mode_360_ram
	LDI  R26,LOW(_EEP_mode360)
	LDI  R27,HIGH(_EEP_mode360)
	RCALL __EEPROMWRB
; 0000 031B 
; 0000 031C                     BUZ_1=1;
	SBI  0x12,4
; 0000 031D                     delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 031E                     BUZ_1=0;
	CBI  0x12,4
; 0000 031F                     delay_ms(50);
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0320                     BUZ_1=1;
	SBI  0x12,4
; 0000 0321                     delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0322                     BUZ_1=0;      //   
	CBI  0x12,4
; 0000 0323                  }
; 0000 0324             }
_0xD5:
; 0000 0325 
; 0000 0326             div_blink++; //    
_0xD4:
	LDD  R30,Y+2
	SUBI R30,-LOW(1)
	STD  Y+2,R30
; 0000 0327             blinker(div_blink,prog_mode); //    
	ST   -Y,R30
	MOV  R26,R20
	RCALL _blinker
; 0000 0328 
; 0000 0329 
; 0000 032A             switch(prog_mode ){
	MOV  R30,R20
; 0000 032B                 //   ,   .
; 0000 032C                 case 0:  // 
	CPI  R30,0
	BRNE _0xE1
; 0000 032D                     gCallibr.OutPPM_Min[0]+= ask_keys();
	RCALL _ask_keys
	LDS  R26,_gCallibr
	LDS  R27,_gCallibr+1
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ADD  R30,R26
	ADC  R31,R27
	STS  _gCallibr,R30
	STS  _gCallibr+1,R31
; 0000 032E                     gCallibr.OutPPM_Min[0] = check_servo_limit(gCallibr.OutPPM_Min[0]);
	LDS  R26,_gCallibr
	LDS  R27,_gCallibr+1
	RCALL _check_servo_limit
	STS  _gCallibr,R30
	STS  _gCallibr+1,R31
; 0000 032F                     send_chanel_ppm(0,gCallibr.OutPPM_Min[0]); //   
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,_gCallibr
	LDS  R27,_gCallibr+1
	RCALL _send_chanel_ppm
; 0000 0330                 break;
	RJMP _0xE0
; 0000 0331                 case 1: // 
_0xE1:
	CPI  R30,LOW(0x1)
	BRNE _0xE2
; 0000 0332                    gCallibr.OutPPM_Max[0]+= ask_keys();
	RCALL _ask_keys
	__GETW2MN _gCallibr,4
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1MN _gCallibr,4
; 0000 0333                    gCallibr.OutPPM_Max[0] = check_servo_limit(gCallibr.OutPPM_Max[0]);
	__GETW2MN _gCallibr,4
	RCALL _check_servo_limit
	__PUTW1MN _gCallibr,4
; 0000 0334                    send_chanel_ppm(0,gCallibr.OutPPM_Max[0]); //   
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETW2MN _gCallibr,4
	RCALL _send_chanel_ppm
; 0000 0335                 break;
	RJMP _0xE0
; 0000 0336                 case 2: // 
_0xE2:
	CPI  R30,LOW(0x2)
	BRNE _0xE3
; 0000 0337                     gCallibr.OutPPM_Min[1]+= ask_keys();
	RCALL _ask_keys
	__GETW2MN _gCallibr,2
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1MN _gCallibr,2
; 0000 0338                     gCallibr.OutPPM_Min[1] = check_servo_limit(gCallibr.OutPPM_Min[1]);
	__GETW2MN _gCallibr,2
	RCALL _check_servo_limit
	__PUTW1MN _gCallibr,2
; 0000 0339                     send_chanel_ppm(1,gCallibr.OutPPM_Min[1]); //   
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETW2MN _gCallibr,2
	RCALL _send_chanel_ppm
; 0000 033A                 break;
	RJMP _0xE0
; 0000 033B                 case 3: // 
_0xE3:
	CPI  R30,LOW(0x3)
	BRNE _0xE4
; 0000 033C                     gCallibr.OutPPM_Max[1]+= ask_keys();
	RCALL _ask_keys
	__GETW2MN _gCallibr,6
	LDI  R31,0
	SBRC R30,7
	SER  R31
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1MN _gCallibr,6
; 0000 033D                     gCallibr.OutPPM_Max[1] = check_servo_limit(gCallibr.OutPPM_Max[1]);
	__GETW2MN _gCallibr,6
	RCALL _check_servo_limit
	__PUTW1MN _gCallibr,6
; 0000 033E                     send_chanel_ppm(1,gCallibr.OutPPM_Max[1]); //   
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETW2MN _gCallibr,6
	RCALL _send_chanel_ppm
; 0000 033F 
; 0000 0340                 break;
	RJMP _0xE0
; 0000 0341                 case 4: //    360/180
_0xE4:
	CPI  R30,LOW(0x4)
	BRNE _0xEF
; 0000 0342                     if(ask_keys() == 0){
	RCALL _ask_keys
	CPI  R30,0
	BRNE _0xE6
; 0000 0343                         //     
; 0000 0344                         div1=0; //          
	LDI  R16,LOW(0)
; 0000 0345                     }
; 0000 0346                     if(ask_keys() > 0 && (++div1 > short_delay)) {
_0xE6:
	RCALL _ask_keys
	CPI  R30,LOW(0x1)
	BRLT _0xE8
	SUBI R16,-LOW(1)
	CPI  R16,26
	BRSH _0xE9
_0xE8:
	RJMP _0xE7
_0xE9:
; 0000 0347                         mode_360_ram=1;
	LDI  R30,LOW(1)
	STS  _mode_360_ram,R30
; 0000 0348                         div_prog = programm_buzz_delay - short_delay; //   
	LDI  R18,LOW(25)
; 0000 0349                         div1=0;
	LDI  R16,LOW(0)
; 0000 034A                     }
; 0000 034B 
; 0000 034C                     if(ask_keys() < 0 && (++div1 > short_delay)) {
_0xE7:
	RCALL _ask_keys
	CPI  R30,0
	BRGE _0xEB
	SUBI R16,-LOW(1)
	CPI  R16,26
	BRSH _0xEC
_0xEB:
	RJMP _0xEA
_0xEC:
; 0000 034D                         mode_360_ram=0;
	LDI  R30,LOW(0)
	STS  _mode_360_ram,R30
; 0000 034E                         div_prog = programm_buzz_delay - short_delay; //   
	LDI  R18,LOW(25)
; 0000 034F                         div1=0;
	LDI  R16,LOW(0)
; 0000 0350                     }
; 0000 0351 
; 0000 0352                     //  
; 0000 0353                     if(mode_360_ram){
_0xEA:
	LDS  R30,_mode_360_ram
	CPI  R30,0
	BREQ _0xED
; 0000 0354                           set_ppm_out(1, 00); //    360 
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RJMP _0xF6
; 0000 0355                     }
; 0000 0356                     else{
_0xED:
; 0000 0357                           set_ppm_out(1, 90); //    180 
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(90)
_0xF6:
	LDI  R27,0
	RCALL _set_ppm_out
; 0000 0358                     }
; 0000 0359 
; 0000 035A 
; 0000 035B                 break;
; 0000 035C                 default:
_0xEF:
; 0000 035D             }
_0xE0:
; 0000 035E 
; 0000 035F         }
_0xC9:
; 0000 0360   }
; 0000 0361   sending_UART();
_0xB2:
	RCALL _sending_UART
; 0000 0362 }
	RJMP _0xAE
; 0000 0363 }
_0xF0:
	RJMP _0xF0
; .FEND
;//------------------------------------------------------

	.CSEG

	.DSEG
_gCallibr:
	.BYTE 0x8
_gVideoBuff:
	.BYTE 0x1C
_gSendUartBuff:
	.BYTE 0x69

	.ESEG

	.ORG 0x10
_EEP_Off_azimuth:
	.BYTE 0x2

	.ORG 0x0

	.ORG 0x12
_EEP_azimuth_min_limit:
	.BYTE 0x2

	.ORG 0x0

	.ORG 0x14
_EEP_azimuth_max_limit:
	.BYTE 0x2

	.ORG 0x0

	.ORG 0x16
_EEP_elevation_min_limit:
	.BYTE 0x2

	.ORG 0x0

	.ORG 0x18
_EEP_elevation_max_limit:
	.BYTE 0x2

	.ORG 0x0

	.ORG 0x1A
_EEP_mode360:
	.BYTE 0x1

	.ORG 0x0

	.DSEG
_gfRX:
	.BYTE 0x1
_gCCNT0:
	.BYTE 0x1
_gOldCnt0:
	.BYTE 0x1
_gErrCnt:
	.BYTE 0x1
_mode_360_ram:
	.BYTE 0x1
_gHostData:
	.BYTE 0x11
_div_S0000004000:
	.BYTE 0x1
_gPPMOldVal:
	.BYTE 0x4
_gPPMOldMod:
	.BYTE 0x4

	.CSEG

	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x1388
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__ASRW8:
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW01:
	CLR  R0
	CP   R0,R30
	CPC  R0,R31
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
