// Alexanter Yanchak - 
//        1500.
//           . IN_KEY_1 PINC.3
//         5  .
//    -         - 
//         .
// .           2  . 

//  ,        2 

// 1. 	   "LED_ERR"
//	    . (     )
//	
// 2.	   "LED_LowBat"
//	    . 
//	 180   -     , 
//	 360  -  .

// 3.	   "LED_RSSI".
//	  ()  .	

// 4.	 "LED_ERR"  "LED_LowBat"     . 
//	 180   -      .

// 5.	 "LED_ERR","LED_LowBat","LED_RSSI"   360-180.   360     , 
	 180    90 . 

//	  -   .	



#include <mega8.h>
#include <string.h>
#include <delay.h>

#define HIGH(a) (a>>8)
#define LOW(a) (a & 0xff)                     
#define u_char unsigned char 
#define s_char signed char
#define u_int unsigned int 
#define s_int signed int
#define u_long unsigned long 
#define s_long signed long
 
#define LED_ERR PORTD.5
#define LED_LowBat PORTB.0
#define LED_RSSI PORTB.3

#define BUZ_1 PORTD.4
#define BUZ_2 PORTB.3

#define IN_KEY PINB.4
#define IN_KEY_1 PINC.3


#define HSIZE_SCR 96
#asm (".equ HSIZE_SCR=96")
#define BYTES_FROM_STRING (HSIZE_SCR/8)
#asm (".equ BYTES_FROM_STRING=(HSIZE_SCR/8)")
//-------------------------------------------------
struct
{
u_int OutPPM_Min[2];
u_int OutPPM_Max[2];
}gCallibr; 
//----------------------------------------------------------------------
register u_char gNumLine @2;
register u_char* gVideoBuffPoint @5;
#asm (".def gVideoBuffPointL=R5")
#asm (".def gVideoBuffPointH=R6")
#define START_LINE_TT 24
#define COUNT_LINE_TT 2
//----------------------------------------------------------------------
u_char gVideoBuff[COUNT_LINE_TT][BYTES_FROM_STRING+2];
#define SIZE_UART_BUFF 100
#define SYN_UART 0x5a

#define long_delay 200
#define change_mode_delay 50
#define short_delay 25 
#define programm_buzz_delay 50
#define blink_delay 25
//     .
//     .
#define servo_min_limit 1500 // .6ms 
#define servo_max_limit 6000 // 2.4ms

u_char gSendUartCnt;
u_char gSendUartInd;
u_char gSendUartBuff[2+1+1+SIZE_UART_BUFF+1];

u_int gTrack_azimuth;
u_char gTrack_elevation;
u_int gOff_azimuth;

eeprom u_int EEP_Off_azimuth @16;
eeprom u_int EEP_azimuth_min_limit @18;
eeprom u_int EEP_azimuth_max_limit @20;
eeprom u_int EEP_elevation_min_limit @22;
eeprom u_int EEP_elevation_max_limit @24;
eeprom u_char EEP_mode360 @26;

u_char f_flash;
u_char gfRX;
u_char gCCNT0;
u_char gOldCnt0;
u_char gErrCnt;
u_char mode_360_ram;

//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
#define POLINOM 33800   // x^0+x^5+x^12, (15-0)+(15-5)+(15-12)
u_int CalcCRC_TT(u_char *buff)
{
union  { u_int r; u_char rb[2]; } rr;
u_char i;
u_char m, pr;
u_char *p;

p=buff;
rr.r=POLINOM;
for(i=0; i<BYTES_FROM_STRING-1; i++, p++) 
  {
  for(m=1; m; m<<=1)
    {
    pr=(rr.rb[0] & 1);
    rr.r>>=1;
    if(*p & m)  rr.rb[1]|=0x80;
    if(pr)  rr.r^=POLINOM;
    }
  }
return rr.r;
}
//---------------------------------------------------------------
typedef struct
{
//u_char start_byte;      // 1.   0xff
u_char num_frame_line;  // 2.   0x00
s_int Track_azimuth;    // 3,4 
s_int Track_elevation;  // 5,6 u_char enough!! 
u_char Reserve[4];      // 7,8,9,10
u_int  CRC;             // 11,12
}TT_FRAME_00;
//---------------------------------------------------------------
typedef struct
{
//u_char start_byte;      // 1.   0xff
u_char num_frame_line;  // 2.   0x10
u_long GPS_lat;         // 3,4,5,6
u_long GPS_lon;         // 7,8,9,10
u_int  CRC;             // 11,12
}TT_FRAME_01;
//----------------------------------------------------------------------
typedef struct
{
s_int  Track_azimuth;     // 1,2
s_int  Track_elevation;  // 3,4
u_long GPS_lat;          // 5,6,7,8
u_long GPS_lon;          // 9,10,11,12
u_int  AV_RSSI;          // 13,14
u_char AVErrors;         // 15
u_int rezerved;          // 16,17
}TO_HOST_DATA;
//----------------------------------------------------------------------
TO_HOST_DATA gHostData;
//----------------------------------------------------------------------
void rec_v_data(void)
{
u_int n;
TT_FRAME_00 *TT_Frame00;
TT_FRAME_01 *TT_Frame01;

//top line
n=CalcCRC_TT(gVideoBuff[0]);
if(n==0)
  {
  if(gVideoBuff[0][0]==0)
    {
    TT_Frame00=(TT_FRAME_00 *)gVideoBuff[0];
    gTrack_azimuth=TT_Frame00->Track_azimuth;
    gTrack_elevation=(u_char)TT_Frame00->Track_elevation;
    }
  }  
else gErrCnt++;
//bottom line    
n=CalcCRC_TT(gVideoBuff[1]);
if(n==0)
  {
  if(gVideoBuff[1][0]==0x10)
    {    
    TT_Frame01=(TT_FRAME_01 *)gVideoBuff[1];
    gHostData.GPS_lat=TT_Frame01->GPS_lat;
    gHostData.GPS_lon=TT_Frame01->GPS_lon;
    }
  }
else gErrCnt++;
gfRX=1;
if(gErrCnt==0) { gCCNT0=short_delay; TCNT0=0; gOldCnt0=0; } // syn main loop  
}
//----------------------------------------------------------------------
u_int read_adc(u_char adc_input)
{
#define ADC_VREF_TYPE 0x40 // AVCC pin
ADMUX=adc_input | ADC_VREF_TYPE;
delay_us(10);
ADCSRA|=0x40; // Start the AD conversion
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}
//----------------------------------------------------------------------
#define RSSI_R1 2
#define RSSI_R2 10
void GetAV_RSSI(void)
{                                            
u_long ln;
//u_int rssi;

ln=read_adc(0); 
//rssi=((ln*300)/1024)/10

//--
#define LEVEL1 335 //   9,8V 
#define LEVEL2 311 //   9,1V
if(ln<LEVEL2) { LED_LowBat=1; BUZ_2=1;}
else if(ln<LEVEL1) { LED_LowBat=f_flash; BUZ_2=f_flash; }
else { LED_LowBat=0; BUZ_2=0; }
gHostData.AV_RSSI=0;
}
//----------------------------------------------------------------------
void GetAVErrors(void)
{
static u_char div;

if(gfRX==0) gErrCnt+=2;
else gfRX=0;
if(div < short_delay) div++;
else
  {
  div=0;
  if(gErrCnt>52) gErrCnt=52;
  if(gErrCnt>short_delay) LED_ERR=1;
  else LED_ERR=0; 
  gHostData.AVErrors=gErrCnt;
  gErrCnt=0;
  }
}
//----------------------------------------------------------------------
void sending_UART(void)
{
if(gSendUartCnt==0) return;
if((UCSRA & 0x20)==0) return;
UDR=gSendUartBuff[gSendUartInd];
gSendUartInd++;
if(gSendUartInd==gSendUartCnt) gSendUartCnt=0;
}
//----------------------------------------------------------------------
void send_UART(u_char type, u_char *buff, u_char cnt, u_char force)
{
u_char crc, i;
u_char *p;

if(gSendUartCnt!=0 && force==0) return;
gSendUartCnt=0;
gSendUartInd=0;
p=gSendUartBuff;
*p++=SYN_UART;
*p++=cnt;
crc=cnt;
*p++=type;
crc^=type;
for(i=0; i<cnt; i++)
  {
  crc^=buff[i];
  *p++=buff[i];
  }
*p++=crc;
*p++='\r';
*p='\n';  
gSendUartCnt=1+1+1+cnt+1+2;
}
//-----------------------------------------------------
//-----------------------------------------------------
//-----------------------------------------------------
interrupt [EXT_INT0] void ext_int0_isr(void)
{ // 
u_char ind;

if(gNumLine < long_delay) gNumLine++;
if(gNumLine >= START_LINE_TT)
  {
  ind=gNumLine-START_LINE_TT;
  if(ind<COUNT_LINE_TT)
    {
//  LED_ERR=1;
    gVideoBuffPoint=gVideoBuff[ind];
    GICR=0x80;  //int0 disable
    MCUCR=0x8A; //sleep=enable
    GIFR=0xc0;  //int0, int1 flag clear
    ACSR=0x1A;  //AC_int=falling, int_flag=clear
    #asm("sei")
    #asm("sleep") //wait AC_int
    return;      
    }
  else if(ind==COUNT_LINE_TT) 
    {
//    #asm("sei")
    rec_v_data();
    }
  }
}
//-----------------------------------------------------
interrupt [EXT_INT1] void ext_int1_isr(void)
{ // 
gNumLine=0;
//  ..:
ACSR=0x00; //AC_int=disable
GICR=0xC0; //int0 enable
}
//-----------------------------------------------------
#pragma savereg-
interrupt [ANA_COMP] void ana_comp_isr(void)
{ // Data
#asm
    ST   -Y,R16   ;2t
    ST   -Y,R17   ;2t
    ST   -Y,R18   ;2t
    ST   -Y,R26   ;2t
    ST   -Y,R27   ;2t
    IN   R16,SREG
    ST   -Y,R16
    
;    CBI  0x12,5    ;LED_ERR=0 !!!
;    
    MOV  R26,gVideoBuffPointL      ;1t
    MOV  R27,gVideoBuffPointH      ;1t
    LDI  R16,(BYTES_FROM_STRING-1) ;1t
;skeep bits    
    LDI  R17,8
_wait_n:
    DEC  R17
    NOP NOP NOP NOP NOP
    BRNE _wait_n
    NOP
;add offset
    NOP
    NOP ; 
    NOP  ; 
    NOP ; 
;    NOP ; 
;    NOP; 
    CLR  R17
_in_ch:
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x10
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x20
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x40
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x80
    NOP NOP NOP NOP
    MOV  R18,R17
    CLR  R17
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x1
    NOP NOP NOP NOP
    ST   X+,R18  ; 2t
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x2
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x4
    SUBI R16,1 ;1t
    NOP NOP NOP NOP NOP

	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x8
    NOP NOP NOP NOP
    BRSH _in_ch ;2t
;    
	LDI  R16,LOW(0)    ;ACSR=0x0; //AC_int=disable
	OUT  0x8,R16
    LDI  R30,LOW(0xC0) ; int0 enable
	OUT  0x3B,R30
	LDI  R16,LOW(0x0A) ; MCUCR=0x0A; //sleep=disable
	OUT  0x35,R16
	LDI  R30,LOW(192) ; int0, int1 flag clear
	OUT  0x3A,R30
    ;    
    LD   R16,Y+
    OUT  SREG,R16
    LD   R27,Y+
    LD   R26,Y+
    LD   R18,Y+ 
	LD   R17,Y+
    LD   R16,Y+
#endasm
}
#pragma savereg+
//-----------------------------------------------------
u_int gPPMOldVal[2];
u_int gPPMOldMod[2];
int abs(int n) { return n > 0 ? n : -n; }
void set_ppm_out(u_char ch, u_int val)
{ 
// val H 0-360 
//val V=90
s_long ul;

s_int new_val, old_val;
s_int m, y;
#define DELAY_CHANGE_PPM (10*5) //2sec

//val=180-val; // Inverted!
y=(gCallibr.OutPPM_Max[ch]-gCallibr.OutPPM_Min[ch]);
ul=y; ul*=val;

if(ch==0){
//    val=360-val;   reverce
    if(mode_360_ram){
        new_val=(s_int)(ul/360);
    }
    else{ 
        new_val=(s_int)(ul/180);
    }
    
    new_val+=gCallibr.OutPPM_Min[ch];
}
else{

    if(mode_360_ram){
         new_val=(s_int)(ul/90); //  360      - 90 
    }else{
         new_val=(s_int)(ul/180); //  180      - 180 
    }   
    new_val+=gCallibr.OutPPM_Min[ch];
}

y=abs(y);
old_val=gPPMOldVal[ch];
if(old_val==new_val) return;
m=gPPMOldMod[ch];
if(old_val<new_val) m+=y; else m-=y;
y=(m/DELAY_CHANGE_PPM);
m-=(y*DELAY_CHANGE_PPM);
gPPMOldMod[ch]=m;
y+=old_val;
if(old_val<new_val && y>new_val);
else if(old_val>new_val && y<new_val);
else new_val=y;
gPPMOldVal[ch]=new_val;
if(ch==0) { OCR1AH=(new_val>>8); OCR1AL=(u_char)new_val; }
else      { OCR1BH=(new_val>>8); OCR1BL=(u_char)new_val; }
}
//----------------------------------------------------------------------
void CalcTrackPos(void)
{
u_int angle;
u_int Azimuth, Elevation;

angle=gTrack_azimuth;

angle+=gOff_azimuth;
//angle=0;
if(angle>=360) {
    angle= angle % 360;
}

if((angle>180) && (!mode_360_ram))
{
// 180  - " "
  Azimuth=(angle-180);
  Elevation=(180-gTrack_elevation);
} 
else
{
    Azimuth= angle;
    Elevation=gTrack_elevation;
}  
    
gHostData.Track_azimuth=Azimuth;
gHostData.Track_elevation=Elevation;
set_ppm_out(0, Azimuth);    
set_ppm_out(1, Elevation);    
}

void send_chanel_ppm(u_char ch, u_int new_val){
    if(ch==0) { OCR1AH=(new_val>>8); OCR1AL=(u_char)new_val; }
    else      { OCR1BH=(new_val>>8); OCR1BL=(u_char)new_val; }
}

void blinker(u_char blink_encounter,u_char mode){
    u_char half_delay;
    half_delay=blink_delay >> 1;
    if((blink_encounter % blink_delay) <= half_delay ){
        switch(mode){
            case 0: 
                LED_ERR=1;
                break;
            case 1:
                LED_LowBat=1;
                break;
            case 2: 
                LED_RSSI=1;
                break;
            case 3:
                LED_ERR=1;
                LED_LowBat=1;
                break; 
            case 4:
                LED_ERR=1;
                LED_LowBat=1;
                LED_RSSI=1;
                break;
            default: 
        }
                
    }else{
        LED_ERR=0;
        LED_LowBat=0;
        LED_RSSI=0;
    }
}

s_char ask_keys(void){
    if(!IN_KEY && !IN_KEY_1) return 0; 
    if(!IN_KEY) return 1; 
    if(!IN_KEY_1) return -1;
    return 0;
}

u_int check_servo_limit_mid(u_int servo_value){
//          .
    if( servo_value < servo_min_limit || servo_value > servo_max_limit){
       
        return 3750; //     
    } 
    return servo_value;
}

u_int check_servo_limit(u_int servo_value){
//      .
    if( servo_value < servo_min_limit){
        BUZ_1=1; // ;
        return servo_min_limit;  
    } 
    
     if( servo_value > servo_max_limit){
        BUZ_1=1; // ;
        return servo_max_limit;  
    }  
    
    return servo_value;
}
//-----------------------------------------------------
void main(void)
{
u_char i, div1, div2,div_prog, wr_wait, prog_mode, old_prog_mode, div_blink;
u_int  prog_wait;

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=P State4=P State3=0 State2=0 State1=0 State0=0 
PORTB=0x30;
DDRB=0x0F;
// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x08;
DDRC=0x00;
// Port D initialization        
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=0 State0=T 
PORTD=0x00;
DDRD=0x32;
// Timer/Counter 0; main loop period 
// Clock source: System Clock
// Clock value: 312,500 kHz
TCCR0=0x03;
TCNT0=0x00;
// Timer/Counter 1; servo-PWM generation
// Clock source: System Clock
// Clock value: 2500,000 kHz
// Mode: Fast PWM top=ICR1
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off



TCCR1A=0xA2;
TCCR1B=0x1A;
TCNT1H=0x00;
TCNT1L=0x00;



ICR1H=HIGH(200*250);
ICR1L=LOW(200*250);

delay_ms(5000);

OCR1AH=HIGH(15*250);
OCR1AL=LOW(15*250);
OCR1BH=HIGH(15*250);
OCR1BL=LOW(15*250);
for(i=0; i<2; i++)  { gPPMOldVal[i]=(15*250); gPPMOldMod[i]=0; }
// Timer/Counter 2; not used 
// Clock source: System Clock
// Clock value: 2500,000 kHz
// Mode: CTC top=OCR2
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x0A;
TCNT2=0x00;
OCR2=160;//159; // 64mks
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
GICR=0xC0;
MCUCR=0x0A;
GIFR=0xC0;
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 38400
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x20;
// Analog Comparator initialization
ACSR=0x00;
SFIOR=0x00;
// ADC initialization
// ADC Clock frequency: 625,000 kHz
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x85;

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!  !!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// ,       
// : K=T(ms)*2500;    
// 3750 1.5ms -- mid
// ..   1ms K=1ms*2500=2500;
//                0.8ms K=0.8*2500=2000;
//for(i=0; i<2; i++)
//  {
//  gCallibr.OutPPM_Min[i]=(100*25); // 1ms
//  gCallibr.OutPPM_Max[i]=(200*25); // 2ms
//  }
//      .   .
//   ,         :
// 
/*
gCallibr.OutPPM_Min[0]=(2763); // 1,08ms  
gCallibr.OutPPM_Max[0]=(4737); // 1,9ms
// 
gCallibr.OutPPM_Min[1]=(2500); // 1,04ms
gCallibr.OutPPM_Max[1]=(4975); // 1,95ms
*/
//         .. :)
//--------------------------------------------------------------------
//  : 1,08 - 1,9 -     1,04 - 1,95 - 
//----------------------------------------------------------------------

//   


gCallibr.OutPPM_Min[0]=check_servo_limit_mid(EEP_azimuth_min_limit);
gCallibr.OutPPM_Max[0]=check_servo_limit_mid(EEP_azimuth_max_limit);
gCallibr.OutPPM_Min[1]=check_servo_limit_mid(EEP_elevation_min_limit);
gCallibr.OutPPM_Max[1]=check_servo_limit_mid(EEP_elevation_max_limit);
mode_360_ram = EEP_mode360;

gNumLine=0;
gVideoBuffPoint=gVideoBuff[0];
div1=0; div2=0; wr_wait=0; prog_wait=0;
div_prog=0;prog_mode=0; div_blink=0;

gTrack_azimuth=0;
gTrack_elevation=0;
if(EEP_Off_azimuth>=360){
    EEP_Off_azimuth=EEP_Off_azimuth % 360;
}
gOff_azimuth=EEP_Off_azimuth;
// testing leds
delay_ms(150);
BUZ_1=1; LED_ERR=1;
delay_ms(100);
BUZ_1=0; LED_ERR=0;
delay_ms(100);
BUZ_1=1; BUZ_1=1;
delay_ms(100);
BUZ_1=0; BUZ_1=0;
delay_ms(100);
LED_LowBat=1; BUZ_2=1;
delay_ms(100);
LED_LowBat=0; BUZ_2=0;
delay_ms(100);
LED_LowBat=1; BUZ_2=1;
delay_ms(100);
LED_LowBat=0; BUZ_2=0;
delay_ms(150);
//
//ff=0;



#asm("sei")
while(1)
  {  
  i=TCNT0;  //period CNT0 (1000/312500)*256=0.82ms
  if(i<gOldCnt0) gCCNT0++;
  gOldCnt0=i;     
  if(gCCNT0 > short_delay){ //20.5ms
      
        gCCNT0=0; 
    
        if (prog_wait < long_delay){
        
            if(!IN_KEY && !IN_KEY_1){
                 set_ppm_out(0, 180); //   
                 set_ppm_out(1, 0); //   
                 prog_wait++;  //    
                 BUZ_1=0; // 
                 continue;
            }   
            
            prog_wait=0; //     
    
            if(!IN_KEY) {
                 wr_wait=1;
                 if(++gOff_azimuth>=360){
                      gOff_azimuth=0;
                 } 
            }  
    
            if(!IN_KEY_1) {
                wr_wait=1;
                if(--gOff_azimuth<=0 || gOff_azimuth>359){
                     gOff_azimuth=359;
                } 
            }
    
            if(wr_wait){
                if(++wr_wait== long_delay ) {
                     wr_wait=0;  
                    EEP_Off_azimuth=gOff_azimuth; 
                }
            }
            
            GetAVErrors();
            GetAV_RSSI();
             
            if(++div1>=5){
                div1=0;
                f_flash^=1;
                if(++div2>=5){
                    div2=0; 
                    if(gHostData.AVErrors>50){
                        BUZ_1=1;
                    } 
                }
                else BUZ_1=0; 
            }
//    if(ff==0) 
            send_UART(0, (u_char *)&gHostData, sizeof(TO_HOST_DATA), 1);
//    else send_UART(ff , gVideoBuff[ff-1] ,12, 1);
//    if(++ff>2) ff=0;
            CalcTrackPos(); 
        }else{  //Programming Mode
            if(div_prog < programm_buzz_delay){  //Song Beep about Programming
                BUZ_1=1;
                div_prog++;
            } else{
                  BUZ_1=0;
            }
            
            
            old_prog_mode = prog_mode;
            if(!IN_KEY && !IN_KEY_1){
                 prog_wait++;  //   
            }else{
                 prog_wait= (int) long_delay + (int)prog_mode * change_mode_delay; //   
            } 
            
            prog_mode = (u_int) (prog_wait - long_delay)/change_mode_delay; //   
            
            if( old_prog_mode != prog_mode){
                 div_prog=0; // Song Beep 
                 if(prog_mode>4){
                    prog_wait=0;//       
                    blinker(blink_delay-1,0); //    
                    //    
                    
                    EEP_azimuth_min_limit = gCallibr.OutPPM_Min[0];
                    EEP_azimuth_max_limit = gCallibr.OutPPM_Max[0];
                    EEP_elevation_min_limit = gCallibr.OutPPM_Min[1];
                    EEP_elevation_max_limit = gCallibr.OutPPM_Max[1];
                    EEP_mode360 = mode_360_ram;

                    BUZ_1=1;
                    delay_ms(100);
                    BUZ_1=0;
                    delay_ms(50);
                    BUZ_1=1;
                    delay_ms(100);
                    BUZ_1=0;      //   
                 } 
            }
            
            div_blink++; //    
            blinker(div_blink,prog_mode); //     


            switch(prog_mode ){ 
                //   ,   .
                case 0:  // 
                    gCallibr.OutPPM_Min[0]+= ask_keys(); 
                    gCallibr.OutPPM_Min[0] = check_servo_limit(gCallibr.OutPPM_Min[0]);
                    send_chanel_ppm(0,gCallibr.OutPPM_Min[0]); //   
                break;
                case 1: // 
                   gCallibr.OutPPM_Max[0]+= ask_keys();
                   gCallibr.OutPPM_Max[0] = check_servo_limit(gCallibr.OutPPM_Max[0]); 
                   send_chanel_ppm(0,gCallibr.OutPPM_Max[0]); //   
                break;
                case 2: //  
                    gCallibr.OutPPM_Min[1]+= ask_keys(); 
                    gCallibr.OutPPM_Min[1] = check_servo_limit(gCallibr.OutPPM_Min[1]);
                    send_chanel_ppm(1,gCallibr.OutPPM_Min[1]); //   
                break;
                case 3: // 
                    gCallibr.OutPPM_Max[1]+= ask_keys();
                    gCallibr.OutPPM_Max[1] = check_servo_limit(gCallibr.OutPPM_Max[1]); 
                    send_chanel_ppm(1,gCallibr.OutPPM_Max[1]); //   
               
                break; 
                case 4: //    360/180
                    if(ask_keys() == 0){  
                        //     
                        div1=0; //          
                    }
                    if(ask_keys() > 0 && (++div1 > short_delay)) {
                        mode_360_ram=1; 
                        div_prog = programm_buzz_delay - short_delay; //    
                        div1=0;
                    }
                    
                    if(ask_keys() < 0 && (++div1 > short_delay)) {
                        mode_360_ram=0;                        
                        div_prog = programm_buzz_delay - short_delay; //   
                        div1=0;
                    }
                    
                    //  
                    if(mode_360_ram){
                          set_ppm_out(1, 00); //    360  
                    }
                    else{
                          set_ppm_out(1, 90); //    180   
                    }
                        
                    
                break;
                default: 
            }
             
        }
  }
  sending_UART();  
}
}
//------------------------------------------------------
