
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#asm (".equ HSIZE_SCR=96")
#asm (".equ BYTES_FROM_STRING=(HSIZE_SCR/8)")

struct
{
unsigned int  OutPPM_Min[2];
unsigned int  OutPPM_Max[2];
}gCallibr; 

register unsigned char  gNumLine @2;
register unsigned char * gVideoBuffPoint @5;
#asm (".def gVideoBuffPointL=R5")
#asm (".def gVideoBuffPointH=R6")

unsigned char  gVideoBuff[2][(96/8)+2];

unsigned char  gSendUartCnt;
unsigned char  gSendUartInd;
unsigned char  gSendUartBuff[2+1+1+100+1];

unsigned int  gTrack_azimuth;
unsigned char  gTrack_elevation;
unsigned int  gOff_azimuth;

eeprom unsigned int  EEP_Off_azimuth @16;
eeprom unsigned int  EEP_azimuth_min_limit @18;
eeprom unsigned int  EEP_azimuth_max_limit @20;
eeprom unsigned int  EEP_elevation_min_limit @22;
eeprom unsigned int  EEP_elevation_max_limit @24;
eeprom unsigned char  EEP_mode360 @26;

unsigned char  f_flash;
unsigned char  gfRX;
unsigned char  gCCNT0;
unsigned char  gOldCnt0;
unsigned char  gErrCnt;
unsigned char  mode_360_ram;

unsigned int  CalcCRC_TT(unsigned char  *buff)
{
union  { unsigned int  r; unsigned char  rb[2]; } rr;
unsigned char  i;
unsigned char  m, pr;
unsigned char  *p;

p=buff;
rr.r=33800   ;
for(i=0; i<(96/8)-1; i++, p++) 
{
for(m=1; m; m<<=1)
{
pr=(rr.rb[0] & 1);
rr.r>>=1;
if(*p & m)  rr.rb[1]|=0x80;
if(pr)  rr.r^=33800   ;
}
}
return rr.r;
}

typedef struct
{

unsigned char  num_frame_line;  
signed int Track_azimuth;    
signed int Track_elevation;  
unsigned char  Reserve[4];      
unsigned int   CRC;             
}TT_FRAME_00;

typedef struct
{

unsigned char  num_frame_line;  
unsigned long  GPS_lat;         
unsigned long  GPS_lon;         
unsigned int   CRC;             
}TT_FRAME_01;

typedef struct
{
signed int  Track_azimuth;     
signed int  Track_elevation;  
unsigned long  GPS_lat;          
unsigned long  GPS_lon;          
unsigned int   AV_RSSI;          
unsigned char  AVErrors;         
unsigned int  rezerved;          
}TO_HOST_DATA;

TO_HOST_DATA gHostData;

void rec_v_data(void)
{
unsigned int  n;
TT_FRAME_00 *TT_Frame00;
TT_FRAME_01 *TT_Frame01;

n=CalcCRC_TT(gVideoBuff[0]);
if(n==0)
{
if(gVideoBuff[0][0]==0)
{
TT_Frame00=(TT_FRAME_00 *)gVideoBuff[0];
gTrack_azimuth=TT_Frame00->Track_azimuth;
gTrack_elevation=(unsigned char )TT_Frame00->Track_elevation;
}
}  
else gErrCnt++;

n=CalcCRC_TT(gVideoBuff[1]);
if(n==0)
{
if(gVideoBuff[1][0]==0x10)
{    
TT_Frame01=(TT_FRAME_01 *)gVideoBuff[1];
gHostData.GPS_lat=TT_Frame01->GPS_lat;
gHostData.GPS_lon=TT_Frame01->GPS_lon;
}
}
else gErrCnt++;
gfRX=1;
if(gErrCnt==0) { gCCNT0=25 ; TCNT0=0; gOldCnt0=0; } 
}

unsigned int  read_adc(unsigned char  adc_input)
{
ADMUX=adc_input | 0x40 ;
delay_us(10);
ADCSRA|=0x40; 
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void GetAV_RSSI(void)
{                                            
unsigned long  ln;

ln=read_adc(0); 

if(ln<311 ) { PORTB.0=1; PORTB.3=1;}
else if(ln<335 ) { PORTB.0=f_flash; PORTB.3=f_flash; }
else { PORTB.0=0; PORTB.3=0; }
gHostData.AV_RSSI=0;
}

void GetAVErrors(void)
{
static unsigned char  div;

if(gfRX==0) gErrCnt+=2;
else gfRX=0;
if(div < 25 ) div++;
else
{
div=0;
if(gErrCnt>52) gErrCnt=52;
if(gErrCnt>25 ) PORTD.5=1;
else PORTD.5=0; 
gHostData.AVErrors=gErrCnt;
gErrCnt=0;
}
}

void sending_UART(void)
{
if(gSendUartCnt==0) return;
if((UCSRA & 0x20)==0) return;
UDR=gSendUartBuff[gSendUartInd];
gSendUartInd++;
if(gSendUartInd==gSendUartCnt) gSendUartCnt=0;
}

void send_UART(unsigned char  type, unsigned char  *buff, unsigned char  cnt, unsigned char  force)
{
unsigned char  crc, i;
unsigned char  *p;

if(gSendUartCnt!=0 && force==0) return;
gSendUartCnt=0;
gSendUartInd=0;
p=gSendUartBuff;
*p++=0x5a;
*p++=cnt;
crc=cnt;
*p++=type;
crc^=type;
for(i=0; i<cnt; i++)
{
crc^=buff[i];
*p++=buff[i];
}
*p++=crc;
*p++='\r';
*p='\n';  
gSendUartCnt=1+1+1+cnt+1+2;
}

interrupt [2] void ext_int0_isr(void)
{ 
unsigned char  ind;

if(gNumLine < 200) gNumLine++;
if(gNumLine >= 24)
{
ind=gNumLine-24;
if(ind<2)
{

gVideoBuffPoint=gVideoBuff[ind];
GICR=0x80;  
MCUCR=0x8A; 
GIFR=0xc0;  
ACSR=0x1A;  
#asm("sei")
#asm("sleep") 
return;      
}
else if(ind==2) 
{

rec_v_data();
}
}
}

interrupt [3] void ext_int1_isr(void)
{ 
gNumLine=0;

ACSR=0x00; 
GICR=0xC0; 
}

#pragma savereg-
interrupt [17] void ana_comp_isr(void)
{ 
#asm
    ST   -Y,R16   ;2t
    ST   -Y,R17   ;2t
    ST   -Y,R18   ;2t
    ST   -Y,R26   ;2t
    ST   -Y,R27   ;2t
    IN   R16,SREG
    ST   -Y,R16
    
;    CBI  0x12,5    ;LED_ERR=0 !!!
;    
    MOV  R26,gVideoBuffPointL      ;1t
    MOV  R27,gVideoBuffPointH      ;1t
    LDI  R16,(BYTES_FROM_STRING-1) ;1t
;skeep bits    
    LDI  R17,8
_wait_n:
    DEC  R17
    NOP NOP NOP NOP NOP
    BRNE _wait_n
    NOP
;add offset
    NOP
    NOP ; 
    NOP  ; 
    NOP ; 
;    NOP ; 
;    NOP; 
    CLR  R17
_in_ch:
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x10
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x20
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x40
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x80
    NOP NOP NOP NOP
    MOV  R18,R17
    CLR  R17
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x1
    NOP NOP NOP NOP
    ST   X+,R18  ; 2t
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x2
    NOP NOP NOP NOP NOP NOP
    
	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x4
    SUBI R16,1 ;1t
    NOP NOP NOP NOP NOP

	SBIS 0x8,5 ;ACSR & 0x20
    SBR  R17,0x8
    NOP NOP NOP NOP
    BRSH _in_ch ;2t
;    
	LDI  R16,LOW(0)    ;ACSR=0x0; //AC_int=disable
	OUT  0x8,R16
    LDI  R30,LOW(0xC0) ; int0 enable
	OUT  0x3B,R30
	LDI  R16,LOW(0x0A) ; MCUCR=0x0A; //sleep=disable
	OUT  0x35,R16
	LDI  R30,LOW(192) ; int0, int1 flag clear
	OUT  0x3A,R30
    ;    
    LD   R16,Y+
    OUT  SREG,R16
    LD   R27,Y+
    LD   R26,Y+
    LD   R18,Y+ 
	LD   R17,Y+
    LD   R16,Y+
#endasm
}
#pragma savereg+

unsigned int  gPPMOldVal[2];
unsigned int  gPPMOldMod[2];
int abs(int n) { return n > 0 ? n : -n; }
void set_ppm_out(unsigned char  ch, unsigned int  val)
{ 

signed long ul;

signed int new_val, old_val;
signed int m, y;

y=(gCallibr.OutPPM_Max[ch]-gCallibr.OutPPM_Min[ch]);
ul=y; ul*=val;

if(ch==0){

if(mode_360_ram){
new_val=(signed int)(ul/360);
}
else{ 
new_val=(signed int)(ul/180);
}

new_val+=gCallibr.OutPPM_Min[ch];
}
else{

if(mode_360_ram){
new_val=(signed int)(ul/90); 
}else{
new_val=(signed int)(ul/180); 
}   
new_val+=gCallibr.OutPPM_Min[ch];
}

y=abs(y);
old_val=gPPMOldVal[ch];
if(old_val==new_val) return;
m=gPPMOldMod[ch];
if(old_val<new_val) m+=y; else m-=y;
y=(m/(10*5) );
m-=(y*(10*5) );
gPPMOldMod[ch]=m;
y+=old_val;
if(old_val<new_val && y>new_val);
else if(old_val>new_val && y<new_val);
else new_val=y;
gPPMOldVal[ch]=new_val;
if(ch==0) { OCR1AH=(new_val>>8); OCR1AL=(unsigned char )new_val; }
else      { OCR1BH=(new_val>>8); OCR1BL=(unsigned char )new_val; }
}

void CalcTrackPos(void)
{
unsigned int  angle;
unsigned int  Azimuth, Elevation;

angle=gTrack_azimuth;

angle+=gOff_azimuth;

if(angle>=360) {
angle= angle % 360;
}

if((angle>180) && (!mode_360_ram))
{

Azimuth=(angle-180);
Elevation=(180-gTrack_elevation);
} 
else
{
Azimuth= angle;
Elevation=gTrack_elevation;
}  

gHostData.Track_azimuth=Azimuth;
gHostData.Track_elevation=Elevation;
set_ppm_out(0, Azimuth);    
set_ppm_out(1, Elevation);    
}

void send_chanel_ppm(unsigned char  ch, unsigned int  new_val){
if(ch==0) { OCR1AH=(new_val>>8); OCR1AL=(unsigned char )new_val; }
else      { OCR1BH=(new_val>>8); OCR1BL=(unsigned char )new_val; }
}

void blinker(unsigned char  blink_encounter,unsigned char  mode){
unsigned char  half_delay;
half_delay=25 >> 1;
if((blink_encounter % 25) <= half_delay ){
switch(mode){
case 0: 
PORTD.5=1;
break;
case 1:
PORTB.0=1;
break;
case 2: 
PORTB.3=1;
break;
case 3:
PORTD.5=1;
PORTB.0=1;
break; 
case 4:
PORTD.5=1;
PORTB.0=1;
PORTB.3=1;
break;
default: 
}

}else{
PORTD.5=0;
PORTB.0=0;
PORTB.3=0;
}
}

signed char ask_keys(void){
if(!PINB.4 && !PINC.3) return 0; 
if(!PINB.4) return 1; 
if(!PINC.3) return -1;
return 0;
}

unsigned int  check_servo_limit_mid(unsigned int  servo_value){

if( servo_value < 1500  || servo_value > 6000 ){

return 3750; 
} 
return servo_value;
}

unsigned int  check_servo_limit(unsigned int  servo_value){

if( servo_value < 1500 ){
PORTD.4=1; 
return 1500 ;  
} 

if( servo_value > 6000 ){
PORTD.4=1; 
return 6000 ;  
}  

return servo_value;
}

void main(void)
{
unsigned char  i, div1, div2,div_prog, wr_wait, prog_mode, old_prog_mode, div_blink;
unsigned int   prog_wait;

PORTB=0x30;
DDRB=0x0F;

PORTC=0x08;
DDRC=0x00;

PORTD=0x00;
DDRD=0x32;

TCCR0=0x03;
TCNT0=0x00;

TCCR1A=0xA2;
TCCR1B=0x1A;
TCNT1H=0x00;
TCNT1L=0x00;

ICR1H=(200*250>>8);
ICR1L=(200*250 & 0xff)                     ;

delay_ms(5000);

OCR1AH=(15*250>>8);
OCR1AL=(15*250 & 0xff)                     ;
OCR1BH=(15*250>>8);
OCR1BL=(15*250 & 0xff)                     ;
for(i=0; i<2; i++)  { gPPMOldVal[i]=(15*250); gPPMOldMod[i]=0; }

ASSR=0x00;
TCCR2=0x0A;
TCNT2=0x00;
OCR2=160;

GICR=0xC0;
MCUCR=0x0A;
GIFR=0xC0;

TIMSK=0x00;

UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x20;

ACSR=0x00;
SFIOR=0x00;

ADMUX=0x40 ;
ADCSRA=0x85;

gCallibr.OutPPM_Min[0]=check_servo_limit_mid(EEP_azimuth_min_limit);
gCallibr.OutPPM_Max[0]=check_servo_limit_mid(EEP_azimuth_max_limit);
gCallibr.OutPPM_Min[1]=check_servo_limit_mid(EEP_elevation_min_limit);
gCallibr.OutPPM_Max[1]=check_servo_limit_mid(EEP_elevation_max_limit);
mode_360_ram = EEP_mode360;

gNumLine=0;
gVideoBuffPoint=gVideoBuff[0];
div1=0; div2=0; wr_wait=0; prog_wait=0;
div_prog=0;prog_mode=0; div_blink=0;

gTrack_azimuth=0;
gTrack_elevation=0;
if(EEP_Off_azimuth>=360){
EEP_Off_azimuth=EEP_Off_azimuth % 360;
}
gOff_azimuth=EEP_Off_azimuth;

delay_ms(150);
PORTD.4=1; PORTD.5=1;
delay_ms(100);
PORTD.4=0; PORTD.5=0;
delay_ms(100);
PORTD.4=1; PORTD.4=1;
delay_ms(100);
PORTD.4=0; PORTD.4=0;
delay_ms(100);
PORTB.0=1; PORTB.3=1;
delay_ms(100);
PORTB.0=0; PORTB.3=0;
delay_ms(100);
PORTB.0=1; PORTB.3=1;
delay_ms(100);
PORTB.0=0; PORTB.3=0;
delay_ms(150);

#asm("sei")
while(1)
{  
i=TCNT0;  
if(i<gOldCnt0) gCCNT0++;
gOldCnt0=i;     
if(gCCNT0 > 25 ){ 

gCCNT0=0; 

if (prog_wait < 200){

if(!PINB.4 && !PINC.3){
set_ppm_out(0, 180); 
set_ppm_out(1, 0); 
prog_wait++;  
PORTD.4=0; 
continue;
}   

prog_wait=0; 

if(!PINB.4) {
wr_wait=1;
if(++gOff_azimuth>=360){
gOff_azimuth=0;
} 
}  

if(!PINC.3) {
wr_wait=1;
if(--gOff_azimuth<=0 || gOff_azimuth>359){
gOff_azimuth=359;
} 
}

if(wr_wait){
if(++wr_wait== 200 ) {
wr_wait=0;  
EEP_Off_azimuth=gOff_azimuth; 
}
}

GetAVErrors();
GetAV_RSSI();

if(++div1>=5){
div1=0;
f_flash^=1;
if(++div2>=5){
div2=0; 
if(gHostData.AVErrors>50){
PORTD.4=1;
} 
}
else PORTD.4=0; 
}

send_UART(0, (unsigned char  *)&gHostData, sizeof(TO_HOST_DATA), 1);

CalcTrackPos(); 
}else{  
if(div_prog < 50){  
PORTD.4=1;
div_prog++;
} else{
PORTD.4=0;
}

old_prog_mode = prog_mode;
if(!PINB.4 && !PINC.3){
prog_wait++;  
}else{
prog_wait= (int) 200 + (int)prog_mode * 50; 
} 

prog_mode = (unsigned int ) (prog_wait - 200)/50; 

if( old_prog_mode != prog_mode){
div_prog=0; 
if(prog_mode>4){
prog_wait=0;
blinker(25-1,0); 

EEP_azimuth_min_limit = gCallibr.OutPPM_Min[0];
EEP_azimuth_max_limit = gCallibr.OutPPM_Max[0];
EEP_elevation_min_limit = gCallibr.OutPPM_Min[1];
EEP_elevation_max_limit = gCallibr.OutPPM_Max[1];
EEP_mode360 = mode_360_ram;

PORTD.4=1;
delay_ms(100);
PORTD.4=0;
delay_ms(50);
PORTD.4=1;
delay_ms(100);
PORTD.4=0;      
} 
}

div_blink++; 
blinker(div_blink,prog_mode); 

switch(prog_mode ){ 

case 0:  
gCallibr.OutPPM_Min[0]+= ask_keys(); 
gCallibr.OutPPM_Min[0] = check_servo_limit(gCallibr.OutPPM_Min[0]);
send_chanel_ppm(0,gCallibr.OutPPM_Min[0]); 
break;
case 1: 
gCallibr.OutPPM_Max[0]+= ask_keys();
gCallibr.OutPPM_Max[0] = check_servo_limit(gCallibr.OutPPM_Max[0]); 
send_chanel_ppm(0,gCallibr.OutPPM_Max[0]); 
break;
case 2: 
gCallibr.OutPPM_Min[1]+= ask_keys(); 
gCallibr.OutPPM_Min[1] = check_servo_limit(gCallibr.OutPPM_Min[1]);
send_chanel_ppm(1,gCallibr.OutPPM_Min[1]); 
break;
case 3: 
gCallibr.OutPPM_Max[1]+= ask_keys();
gCallibr.OutPPM_Max[1] = check_servo_limit(gCallibr.OutPPM_Max[1]); 
send_chanel_ppm(1,gCallibr.OutPPM_Max[1]); 

break; 
case 4: 
if(ask_keys() == 0){  

div1=0; 
}
if(ask_keys() > 0 && (++div1 > 25 )) {
mode_360_ram=1; 
div_prog = 50 - 25 ; 
div1=0;
}

if(ask_keys() < 0 && (++div1 > 25 )) {
mode_360_ram=0;                        
div_prog = 50 - 25 ; 
div1=0;
}

if(mode_360_ram){
set_ppm_out(1, 00); 
}
else{
set_ppm_out(1, 90); 
}

break;
default: 
}

}
}
sending_UART();  
}
}

